import com.adventnet.qengine.web.server.core.WFObjectHolder as wfObjHandler;
import com.adventnet.qengine.web.replay.PlayBackUtil as playBack;
import com.adventnet.qengine.serverfwk.validation.DataDriver as DataDriver;
import com.adventnet.qengine.serverfwk.util.StringFunctions as StringFunctions;
import com.adventnet.qengine.serverfwk.util.FileOperation as FileOperation;
import com.adventnet.qengine.serverfwk.util.DateTimeFunctions as DateFunctions;
import com.adventnet.qengine.serverfwk.validation.MailValidator as MailValidator;

import java.lang.System as System;
import java.lang.Thread as Thread;

wfobj=wfObjHandler().getInstance();
playback=playBack.getInstance();
datadriver=DataDriver().getNewInstance();
stringfunctions=StringFunctions().getNewInstance();
dateFunctions=DateFunctions().getNewInstance();
fileOperation=FileOperation().getNewInstance();
mailValidator=MailValidator().getNewInstance(); 

def setRequiredInstances(varValue):
	global playback
	tempins=wfobj.getPlayBackInstance(varValue);
	playback=tempins;
	datadriver.setRequiredInstances(playback.getWebDataUtil(),playback.logger);
	playback.setDataDriverInstance(datadriver);
	stringfunctions.setRequiredInstances(playback.getWebDataUtil());
	playback.setStringFunctionsInstance(stringfunctions);
	mailValidator.setRequiredInstances(playback.getWebDataUtil(),playback.logger);
	playback.setMailValidatorInstance(mailValidator);
	playback.setDateFunctionsInstance(dateFunctions);
	playback.setFileOperationInstance(fileOperation);
	playback.checkForCompilationMode();


def launchApplication(URL):
	return playback.launchApplication(URL);

def setGlobal(objname, objvalue):
	return playback.setGlobal(objname, objvalue);

def getGlobal(objname):
	return playback.getGlobal(objname);
	
def setTestVariable(objname, objvalue):
	return playback.setTestVariable(objname, objvalue);

def getTestVariable(objname):
	return playback.getTestVariable(objname);

def setEnvironmentVariable(objname, objvalue):
	return playback.setEnvironmentVariable(objname, objvalue);

def getEnvironmentVariable(objname):
	return playback.getEnvironmentVariable(objname);


def callScript(scriptname,scriptpath):
	return playback.callScript(scriptname,scriptpath);

def callScriptUpto(scriptname,scriptpath,endindex):
	return playback.callScriptUpto(scriptname,scriptpath,endindex);

def callScriptFrom(scriptname,scriptpath,fromindex):
	return playback.callScriptFrom(scriptname,scriptpath,fromindex);

def setWindow(windowname,waittime,propertyname="",propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.setWindow(windowname,waittime);

def setHTMLPopup(windowname,waittime):
	return playback.setHTMLPopup(windowname,waittime);

def setTopWindow(windowname,index,waittime):
	return playback.setTopWindow(windowname,index,waittime);

def setDialog(windowname,waittime):
	return playback.setDialog(windowname,waittime);

def setDialogWindow(windowname,waittime,propertyname="",propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.setDialogWindow(windowname,waittime);

def closeWindow(windowname,waittime):
	return playback.closeWindow(windowname,waittime);

def closeDialog(windowname,waittime):
	return playback.closeDialog(windowname,waittime);

def clickMainToolBarButton(buttonName,waittime):
	return playback.clickMainToolBarButton(buttonName,waittime);

def changeURL(url,waittime):
	return playback.changeURL(url,waittime);

def clearCookies(domain="all"):
	return playback.clearCookies(domain);

def clearCache():
	return playback.clearCache();

def executeJavaScript(cmd):
	return playback.executeJavaScript(cmd);

def useLocalMapFile():
	playback.useLocalMapFile();
	return 0;

def useMapFile(filePath):
	playback.useMapFile(filePath);
	return 0;

def useSuiteLevelMapFile():
	displayMessage("suite level map file set ")
	playback.useSuiteLevelMapFile();
	return 0;

def useGlobalMapFile():
    	playback.useSuiteLevelMapFile();
	return 0;

def changeLocale(language, country):
	playback.changeLocale(language, country);
	return 0;

def getLocaleLanguage():
	result = playback.getLocaleLanguage();
	return result;

def getLocalizedString(stringName):
	result = playback.getLocalizedString(stringName);
	return result;

def getLocaleCountry():
	result = playback.getLocaleCountry();
	return result;

def setText(textFieldName,text,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.setText(textFieldName,text,waittime);

def keyInText(textFieldName,text,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.keyInText(textFieldName,text,waittime);

def clickLink(linkName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.clickLink(linkName,waittime);

def clickImage(imageName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.clickImage(imageName,waittime);

def clickMap(mapName,coords,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.clickMap(mapName,coords,waittime);

def clickButton(buttonName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.clickButton(buttonName,waittime);

def keyPressed(elementName,key,splkey,waittime,propertyname="",propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.keyPressed(elementName,key,splkey,waittime);

def clickElement(elementName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.clickElement(elementName,waittime);

def selectItem(componentName,value,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.selectItem(componentName,value,waittime);

def selectItemWithIndex(componentName,selectindex,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.selectItemWithIndex(componentName,selectindex,waittime);

def clickList(elementName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.clickList(elementName,waittime);

def dragAndDrop(srcelementname,destelementname,waittime,propertyname="",propertyvalue="",propertyname1="",propertyvalue1=""):
	return playback.dragAndDrop(srcelementname,destelementname,waittime,propertyname,propertyvalue,propertyname1,propertyvalue1);

def dragAndDropAnalog(srcelementname,destx="-1",desty="-1",waittime=1):
	return playback.dragAndDropAnalog(srcelementname,destx,desty,waittime);

def doubleClick(elementName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.doubleClick(elementName,waittime);

def fireMouseOver(elementName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.mouseOver(elementName,waittime);

def mouseOver(elementName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.mouseOver(elementName,waittime);

def waitForElement(elementName,timeout=-1,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.waitForElement(elementName,timeout);

def waitForWindowStatus(status="Done",timeout=-1):
	return playback.waitForWindowStatusText(status,timeout);

def waitForDynamicElement(tagName,propertyName,propertyValue,index,timeout=-1,regExpRequired="false"):
	return playback.waitForDynamicElement(tagName,propertyName,propertyValue,index,regExpRequired,timeout);

def waitForDynamicElementById(elementId,timeout=-1,index=1,regExpRequired="false"):
	return playback.waitForDynamicElementById(elementId,timeout,index,regExpRequired);

def waitForElementRemoval(elementName,timeout=-1,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.waitForElementRemoval(elementName,timeout);

def waitForDynamicElementRemoval(tagName,propertyName,propertyValue,index,timeout=-1,regExpRequired="false"):
	return playback.waitForDynamicElementRemoval(tagName,propertyName,propertyValue,index,regExpRequired,timeout);

def waitForDynamicElementRemovalById(elementId,timeout=-1,index=1,regExpRequired="false"):
	return playback.waitForDynamicElementRemovalById(elementId,timeout,index,regExpRequired);

def waitForElementPropertyChange(elementName,reqPropName,reqPropValue,timeout=-1,propertyname="",propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.waitForElementPropertyChange(elementName,reqPropName,reqPropValue,timeout);

def waitForDynamicElementPropertyChange(tagName,propertyName,propertyValue,index,reqPropName,reqPropValue,timeout=-1,regExpRequired="false"):
	return playback.waitForDynamicElementPropertyChange(tagName,propertyName,propertyValue,index,reqPropName,reqPropValue,regExpRequired,timeout);

def waitForDynamicElementPropertyChangeById(elementId,reqPropName,reqPropValue,timeout=-1,index=1,regExpRequired="false"):
	return playback.waitForDynamicElementPropertyChangeById(elementId,reqPropName,reqPropValue,timeout,index,regExpRequired);
	
def waitForText(searchText,prefixText="EMPTY",suffixText="EMPTY",timeout=-1):
	return playback.waitForText(searchText,prefixText,suffixText,timeout);

def waitForTitle(parenttitle,parentindex,timeout=-1,framepropertyname="NONE",framepropertyvalue="NONE",frameindex=1):
	return playback.waitForTitle(parenttitle,parentindex,framepropertyname,framepropertyvalue,frameindex,timeout);
	
def enableWaitForElement(state,timeout=-1):
	return playback.enableWaitForElement(state,timeout);

def setWaitTimeForElement(timeout):
	return playback.setWaitTimeForElement(timeout);

def showContextMenu(elementName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.mouseRightClick(elementName,waittime);	


def setAlertWindow(windowName,waittime,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.setAlertWindow(windowName,waittime);

def closeAlertWindow(windowName,waittime):
	return playback.closeAlertWindow(windowName,waittime);

def executeTest(caseID):
	return playback.executeTest(caseID);


def getElementWithFocus(propertyName):
	return playback.getElementWithFocus(propertyName);

def closeAllWindows():
	return playback.closeAllWindows();

def doesWindowExists(parenttitle,parentindex=1,framepropertyname="NONE",framepropertyvalue="NONE",frameindex=1):
	return playback.doesWindowExists(parenttitle,parentindex,framepropertyname,framepropertyvalue,frameindex);

def doesDialogWindowExists(dialogtitle,framepropertyname="NONE",framepropertyvalue="NONE",frameindex=1):	 
	return playback.doesDialogWindowExists(dialogtitle,framepropertyname,framepropertyvalue,frameindex);

def doesPopUpExists(jtitle):
	return playback.doesPopUpExists(jtitle);

def closePopUp(title,waittime):
	return playback.closePopUp(title,waittime);
	
def setDynamicWindow(parenttitle,parentindex=1,framepropertyname="NONE",framepropertyvalue="NONE",frameindex=1):
	return playback.setDynamicWindow(parenttitle,parentindex,framepropertyname,framepropertyvalue,frameindex);

def setDynamicDialogWindow(dialogtitle,framepropertyname="NONE",framepropertyvalue="NONE",frameindex=1):	 
	return playback.setDynamicDialogWindow(dialogtitle,framepropertyname,framepropertyvalue,frameindex);

def closeDynamicWindow(parenttitle,parentindex=1):
	return playback.closeDynamicWindow(parenttitle,parentindex);

def closeLastWindow():
	return playback.closeLastWindow();

def getWindowTitle():
	return playback.getWindowTitle();

def getWindowStatus():
	return playback.getWindowStatusText();

def getLastWindowTitle():
	return playback.getLastWindowTitle();

def setLastWindow(windowname="",waittime=1):
	return playback.setLastWindow(windowname,waittime);

def getWindowURL():
	return playback.getWindowURL();

def getLastWindowURL():
	return playback.getLastWindowURL();

def getLastWindowDocumentType():
	return playback.getLastWindowDocumentType();

def getLastWindowId(type=""):
	return playback.getLastWindowId(type);

def doesElementExists(tagName,propertyName,propertyValue,index,regExpRequired="false"):
	return playback.doesElementExists(tagName,propertyName,propertyValue,index,regExpRequired);

def getElementIdentifier(tagName,propertyName,propertyValue,index,propertyNeeded,regExpRequired="false"):
	return playback.getElementIdentifier(tagName,propertyName,propertyValue,index,propertyNeeded,regExpRequired);

def getElementProperty(tagName,propertyName,propertyValue,index,propertyNeeded,regExpRequired="false"):
	return playback.getElementIdentifier(tagName,propertyName,propertyValue,index,propertyNeeded,regExpRequired);

def getElementPropertyById(elementId,propertyNeeded,index=1,regExpRequired="false"):
	return playback.getElementPropertyById(elementId,propertyNeeded,index,regExpRequired);

def checkElementProperty(tagName,propertyName,propertyValue,index,propertyNeeded,matchValue,caseid="",regExpRequired="false"):
	return playback.checkElementProperty(tagName,propertyName,propertyValue,index,propertyNeeded,matchValue,caseid,regExpRequired);

def checkElementPropertyById(elementId,propertyNeeded,matchValue,caseid="",index=1,regExpRequired="false"):
	return playback.checkElementPropertyById(elementId,propertyNeeded,matchValue,caseid,index,regExpRequired);
	
def getCellElementProperty(tableid,rowindex, colindex, propertyNeeded,tagName="NONE",propertyName="NONE",propertyValue="NONE",index=1):
	return playback.getCellElementProperty(tableid,rowindex, colindex, propertyNeeded,tagName,propertyName,propertyValue,index);

def fireEventOnElement(tagName,propertyName,propertyValue,index,actionName,actionValue="",regExpRequired="false"):
	return playback.fireEventOnElement(tagName,propertyName,propertyValue,index,actionName,actionValue,regExpRequired);

def fireEventOnElementById(elementId,actionName,actionValue="",index=1,regExpRequired="false"):
	return playback.fireEventOnElementById(elementId,actionName,actionValue,index,regExpRequired);

def fireEventOnChildElement(tagName,propertyName,propertyValue,index,identifier,actionName,actionValue="",childpropname="",childpropval="",childindex=1,childRegExp="false",parentRegExp="false"):
	return playback.fireEventOnChildElement(tagName,propertyName,propertyValue,index,identifier,actionName,actionValue,childpropname,childpropval,childindex,childRegExp,parentRegExp);

def fireEventOnObject(classID,type,xCoord,yCoord,actionName,actionValue=""):
	return playback.fireEventOnObject(classID,type,xCoord,yCoord,actionName,actionValue);

def fireEventAtPosition(title,classID,xCoord,yCoord,actionName,actionValue="",waittime=1):
	return playback.fireEventAtPosition(title,classID,xCoord,yCoord,actionName,actionValue,waittime);	

def fireEventOnCellElement(tableid,rowindex, colindex, actionname,actionvalue="NONE",tag="NONE",propertyname="NONE",propertyvalue="NONE",index=1):
	return playback.fireEventOnCellElement(tableid,rowindex, colindex, actionname,actionvalue,tag,propertyname,propertyvalue,index);

def fireEventOnTableCell(tableprop,tablepropval,tableindex,rowindex,colindex,actionname,actionvalue="NONE",regExpRequired="false"):
	return playback.fireEventOnTableCell(tableprop,tablepropval,tableindex,rowindex,colindex,actionname,actionvalue,regExpRequired);

def fireEventOnTableCellElement(tableprop,tablepropval,tableindex,rowindex,colindex,actionname,actionvalue="NONE",tag="NONE",propname="NONE",propval="NONE",index=1,regExpRequired="false"):
	return playback.fireEventOnTableCellElement(tableprop,tablepropval,tableindex,rowindex,colindex,actionname,actionvalue,tag,propname,propval,index,regExpRequired);

def getHTMLElementCount(tagName,propertyName="",propertyValue="",regExpRequired="false"):
	return playback.getHTMLElementCount(tagName,propertyName,propertyValue,regExpRequired);	

def linkGetInfo(elementId,property,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getInfo(elementId,property);
	return result;

def buttonGetInfo(elementId,property,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getInfo(elementId,property);
	return result;

def imageGetInfo(elementId,property,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getInfo(elementId,property);
	return result;

def editGetInfo(elementId,property,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getInfo(elementId,property);
	return result;

def selectGetInfo(elementId,property,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getInfo(elementId,property);
	return result;

def listGetInfo(elementId,property,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getInfo(elementId,property);
	return result;

def linkCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def buttonCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def imageCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def editCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def selectCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def staticCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def listCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def styleCheckInfo(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def webCheckText(searchText,prefixText="EMPTY",suffixText="EMPTY",caseid=""):
	return playback.webCheckText(searchText,prefixText,suffixText,caseid);
	
def webGetText(prefixstr="EMPTY", suffixstr="EMPTY"):
	return playback.webGetText(prefixstr,suffixstr);

def initDB(dbid,dbConURL="",dbusername="",dbpwd=""):
	return datadriver.initDB(dbid,dbConURL,dbusername,dbpwd);

def initCSV(filename):
	return datadriver.initCSV(filename);
	
def initDataSet(dataSetID,dbConURL="",dbusername="",dbpwd=""):
	return datadriver.initDataSet(dataSetID,dbConURL,dbusername,dbpwd);

def getValuesFrom(resultid):
	result=datadriver.getValuesFrom(resultid);
	return result;

def getDBValueAt(sql,rowindex,colindex):
	result=datadriver.getDBValueAt(sql,rowindex,colindex);
	return result;

def writeToDB(sql):
								
	return datadriver.writeToDB(sql);

def getDBValues(sql):
	return datadriver.getDBValues(sql);

def getDBTableRowCount(sql):
	result=datadriver.getDBTableRowCount(sql);
	return result;

def getDBTableColumnCount(sql):
	result=datadriver.getDBTableColumnCount(sql);
	return result;

def getCSVValueAt(rowindex,colindex):
	result=datadriver.getCSVValueAt(rowindex,colindex);
	return result;

def getEncryptedValue(normaltext):
	result=playback.getEncryptedValue(normaltext);
	return result;

def setLineNumber(lineindex):	
	playback.setLineNumber(lineindex)
	return;

def reportStatus(statusid,result,remarks):
	playback.reportStatus(statusid,result,remarks);
	return 0;

def reportTestCase(caseid,result,remarks,severity,expValue="",actValue=""):
	playback.reportTestCase(caseid,result,remarks,severity,expValue,actValue);

def displayMessage(result):
	playback.displayMessage(result);
	return 0;

def wait(seconds):
	result = playback.callWaitFunction(seconds*1000);
	return result;

def saveScreenShot(outFileName,waittime):
	return playback.saveScreenShot(outFileName, waittime);

def getPopUpText(windowName, waittime):
	result=playback.getPopUpText(windowName, waittime);
	return result;

def getUnExpectedPopUpTitle():
	result=playback.getUnExpectedPopUpTitle();
	return result;

def closeUnExpectedPopUp(windowName, waittime):
	return playback.closeUnExpectedPopUp(windowName, waittime);

def getLastError():
	result=playback.getLastError();
	return result;

def setErrorHandlingScript(scriptName,scriptPath):
        return playback.setErrorHandlingScript(scriptName,scriptPath);

def disableErrorHandling():
        result=playback.disableErrorHandling();
        return result;

def stopAll():
	return playback.stopAll();

def stop():
	return playback.stop();

def pageGetInfo(windowID, propName):
	result=playback.pageGetInfo(windowID, propName);
	return result;

def pageCheckInfo(windowID, propName, propVal,caseid=""):
	return playback.pageCheckInfo(windowID, propName, propVal,caseid);

def winGetInfo(windowID, propName):
	result=playback.winGetInfo(windowID, propName);
	return result;

def winCheckInfo(windowID, propName, propVal, caseid=""):
	return playback.winCheckInfo(windowID, propName, propVal,caseid);

def checkCellValueAt(elementId,key,value,propertyname="", propertyvalue="", caseid=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.checkInfo(elementId,key,value,caseid);

def checkCellValueAtNM(tableprop,tablepropval,tableindex,rowindex,colindex,property,value,caseid="NONE"):
	return playback.checkTableCellValue(tableprop,tablepropval,tableindex,rowindex,colindex,property,value,caseid);

def getAllHTMLTableCells(elementID,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getAllHTMLTableCells(elementID);
	return result;

def getAllHTMLTableCellsNM(tableprop,tablepropval,tableindex):
	result=playback.getAllHTMLTableCellsNM(tableprop,tablepropval,tableindex);
	return result;

def getHTMLTableColumnValues(elementID,colindex,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getHTMLTableColumnValues(elementID,colindex);
	return result;

def getHTMLTableColumnValuesNM(tableprop,tablepropval,tableindex,colindex):
	result=playback.getHTMLTableColumnValuesNM(tableprop,tablepropval,tableindex,colindex);
	return result;

def getHTMLTableRowValues(elementID,rowindex,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getHTMLTableRowValues(elementID,rowindex);
	return result;

def getHTMLTableRowValuesNM(tableprop,tablepropval,tableindex,rowindex):
	result=playback.getHTMLTableRowValuesNM(tableprop,tablepropval,tableindex,rowindex);
	return result;

def getCellValueAt(elementID, rowIdx, columnIdx,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getCellValueAt(elementID, rowIdx, columnIdx);
	return result;

def getCellValueAtNM(tableprop,tablepropval,tableindex,rowindex,colindex,property):
	reqProperty = "cellValueAt-"+str(rowindex)+","+str(colindex);
	return playback.getTableCellProperty(tableprop,tablepropval,tableindex,rowindex,colindex,reqProperty);

def getHTMLTableRowCountNM(tableprop,tablepropval,tableindex):
	return playback.getTableCellProperty(tableprop,tablepropval,tableindex,0,0,"rowCount");
	
def getHTMLTableColumnCountNM(tableprop,tablepropval,tableindex):
	return playback.getTableCellProperty(tableprop,tablepropval,tableindex,0,0,"columnCount");

def getCellHTMLNM(tableprop,tablepropval,tableindex,rowindex,colindex):
	reqProperty = "cellHTML-"+str(rowindex)+","+str(colindex);
	return playback.getTableCellProperty(tableprop,tablepropval,tableindex,rowindex,colindex,reqProperty);

def getCellHTML(elementID, rowIdx, columnIdx,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getCellHTML(elementID, rowIdx, columnIdx);
	return result;

def getHTMLTableHTML(elementID,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.getHTMLTableHTML(elementID);
	return result;

def getHTMLTableHTMLNM(tableprop,tablepropval,tableindex):
	result=playback.getHTMLTableHTMLNM(tableprop,tablepropval,tableindex);
	return result;

def getHTMLTableRowCount(elementID,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.getRowCount(elementID);

def getRowCount(elementID):
	displayMessage("The function getRowCount() has been deprecated. Use function getHTMLTableRowCount() instead of getRowCount(). For more details refer the product documentation.\n");
	return getHTMLTableRowCount(elementID);

def getHTMLTableColumnCount(elementID,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	return playback.getColumnCount(elementID);

def getColumnCount(elementID):
	displayMessage("The function getColumnCount() has been deprecated. Use function getHTMLTableColumnCount() instead of getColumnCount(). For more details refer the product documentation.\n");
	return getHTMLTableColumnCount(elementID);

def invokeApplication(fileName):
	result=playback.invokeApplication(fileName);
	return result;

def invokeApplicationInThread(fileName):
	result=playback.invokeApplication(fileName, "true");
	return result;
def invokeApplicationWithArgs(fileName,arguments):
	result=playback.invokeApplicationWithArgs(fileName,arguments);
	return result;

def invokeApplicationInThreadWithArgs(fileName,arguments):
	result=playback.invokeApplicationWithArgs(fileName,arguments,"true");
	return result;

def submitForm(formName, waittime):
	result=playback.submitForm(formName,waittime);
	return result;

def waitForPageDownload():
	result=playback.waitForPageDownload();
	return result;

def saveLogs(fileName):
	result=playback.saveLogs(fileName);
	return result;
	
def setDownloadTimeLimit(time):
	result=playback.setMaxTimeLimit(time);
	return result;	

def setMouseCapture(mode,elems=""):
	result=playback.setMouseCaptureDetails(mode,elems);
	return result;

def setFastMode(mode="true"):
	return playback.setFastMode(mode);

def doesColumnContain(elementID, rowIdx, columnIdx,sql,columnIndex,propertyname="", propertyvalue=""):
	playback.setOverWritingProp(propertyname,propertyvalue);
	result=playback.doesColumnContain(elementID, rowIdx, columnIdx,sql,columnIndex);
	return result;

def doesColumnContainNM(tableprop, tablepropval, tableindex, rowIdx, columnIdx,sql,columnIndex):
	result=playback.doesColumnContainNM(tableprop, tablepropval, tableindex, rowIdx, columnIdx,sql,columnIndex);
	return result;

def getBrowserType():
	result=playback.getBrowserName();
	return result;
def getBrowserVersion():
	result=playback.getBrowserVersion();
	return result;
def getOSName():
	result=playback.getOSName();
	return result;
def getOSVersion():
	result=playback.getOSVersion();
	return result;

def writeToCSVFile(fileName, valueArray, appendToFile):
	result=playback.writeToCSV(fileName, valueArray, appendToFile);
	return result;

def writeToFile(fileName, valueArray):
	result=playback.writeToFile(fileName, valueArray);
	return result;

def length(completeString):
	result=stringfunctions.length(completeString);
	return result;

def indexOf(completeString,patternString):
	result=stringfunctions.indexOf(completeString,patternString);
	return result;

def subString(completeString,startIndex,endIndex=-1):
	result=stringfunctions.subString(completeString,startIndex,endIndex);
	return result;

def split(completeString,seperator):
	result=stringfunctions.split(completeString,seperator);
	return result;

def startsWith(completeString,startString):
	result=stringfunctions.startsWith(completeString,startString);
	return result;

def endsWith(completeString,endString):
	result=stringfunctions.endsWith(completeString,endString);
	return result;

def toUpperCase(completeString):
	result=stringfunctions.toUpperCase(completeString);
	return result;

def toLowerCase(completeString):
	result=stringfunctions.toLowerCase(completeString);
	return result;

def replaceAll(completeString,stringPatternToFind,stringToReplace):
	result=stringfunctions.replaceAll(completeString,stringPatternToFind,stringToReplace);
	return result;

def replaceFirst(completeString,stringPatternToFind,stringToReplace):
	result=stringfunctions.replaceFirst(completeString,stringPatternToFind,stringToReplace);
	return result;

def getValuesAsMap(filepath,xpathexpression):
	result=datadriver.getValuesAsMap(filepath,xpathexpression);
	return result;
		
def getNodeValues(filepath,xpathexpression):
	result=datadriver.getNodeValues(filepath,xpathexpression);
	return result;
	
def getNodeCount(filepath,xpathexpression):
	result=datadriver.getNodeCount(filepath,xpathexpression);
	return result;
			
def getNodeValue(filepath,xpathexpression):
	result=datadriver.getNodeValue(filepath,xpathexpression);
	return result;
		
def getNodeAttributes(filepath,xpathexpression):
	result=datadriver.getNodeAttributes(filepath,xpathexpression);
	return result;
			
def isNodePresent(filepath,xpathexpression):
	result=datadriver.isNodePresent(filepath,xpathexpression);
	return result;
			
def doesNodeContainValue(filepath,xpathexpression,value):
	result=datadriver.doesNodeContainValue(filepath,xpathexpression,value);
	return result;

def	isXMLSimilar(actualfilepath,expectedfilepath):
	result=datadriver.isXMLSimilar(actualfilepath,expectedfilepath);
	return result;
	
def	isXMLIdentical(actualfilepath,expectedfilepath):
	result=datadriver.isXMLIdentical(actualfilepath,expectedfilepath);
	return result;

def getTextNodeValues(filepath,xpathexpression):
	result=datadriver.getTextNodeValues(filepath,xpathexpression);
	return result;

def getLinesInFile(filename):
	result=fileOperation.getLinesInFile(filename);
	return result;
	
def isStringInFile(searchStr,filename):
	result=fileOperation.isStringInFile(searchStr,filename);
	return result;
	
def getFileCount(filename,counttype):
		
	result=fileOperation.getFileCount(filename,counttype);
	return result;
	
def getStringCountInFile(filename,searchStr):
	result=fileOperation.getStringCountInFile(filename,searchStr);
	return result;

def isFileInZip(zipname,filename):
	result=fileOperation.IsFileInZip(zipname,filename);
	return result;

def isFileExist(filename):
    	result=fileOperation.isFileExist(filename);
	return result;

def isStringInZip(zipname,filename,searchStr):
	result=fileOperation.IsStringInZip(zipname,filename,searchStr);
	return result;
	
def compareFile(basefilename,checkfilename):
	result=fileOperation.CompareFile(basefilename,checkfilename);
	return result;
	
def getFileSize(filename):
	result=fileOperation.getFileSize(filename);
	return result;	

def getFormattedDate(format):
	result=dateFunctions.getCurrentDate(format);
	return result;
	
def getDateTime():
	result=dateFunctions.getDateTime();
	return result;
	
def getDateStr():
	result=dateFunctions.getDateStr();
	return result;
	
def getTimeStr():
	result=dateFunctions.getTimeStr();
	return result;
	
def getTimeLong():
	result=dateFunctions.getTimeLong();
	return result;
	
def adjustDate(format,offset):
	result=dateFunctions.adjustDate(format,offset);
	return result;
	
def adjustGivenDate(indate,offset):
	result=dateFunctions.adjustGivenDate(indate,offset);
	return result;
	
def getDateTimePart(desPart):
	result=dateFunctions.getDateTimePart(desPart);
	return result;
	
def getDateDiff(date1,date2):
	result=dateFunctions.getDateDiff(date1,date2);
	return result;
	
def getDay():
	result=dateFunctions.getDay();
	return result;
	
def getNextDay():
	result=dateFunctions.getNextDay();
	return result;
	
def getPreviousDay():
	result=dateFunctions.getPreviousDay();
	return result;
	
def getHour():
	result=dateFunctions.getHour();
	return result;
	
def getNextHour():
	result=dateFunctions.getNextHour();
	return result;
	
def getPreviousHour():
	result=dateFunctions.getPreviousHour();
	return result;
	
def maximizeWindow():
	return playback.maximizeWindow();

def minimizeWindow():
	return playback.minimizeWindow();

def getRuntimeInput(argstr=""):
	result=playback.getRuntimeInput(argstr);
	return result;

def fetchMails(server,username,password,port=-1,delete="false"):
	return mailValidator.fetchMails(server,port,username,password,delete);

def checkMailProperty(lh1,condition1,rh1,index,lh2,condition2,rh2,timeout=-1):
	return mailValidator.checkMailWithTimeout(lh1,condition1,rh1,index,lh2,condition2,rh2,timeout);

def getMailProperty(lh1,condition1,rh1,getvalue,index,timeout=-1):
	return mailValidator.getMailWithTimeout(lh1,condition1,rh1,getvalue,index,timeout);

def getMailCount(lh1,condition1,rh1,timeout=-1):
	return mailValidator.getMailCountWithTimeout(lh1,condition1,rh1,timeout);

def compareDB_HTMLTableColumn(elementID, columnIdx,datasourceID,columnIndex,excluderow):
	result=playback.compareDB_HTMLTableColumnValues(elementID, columnIdx,datasourceID,columnIndex,excluderow);
	return result;

def compareDB_HTMLTableColumnNM(tableprop, tablepropval, tableindex, columnIdx,datasourceID,columnIndex,excluderow):
	result=playback.compareDB_HTMLTableColumnValuesNM(tableprop, tablepropval, tableindex, columnIdx,datasourceID,columnIndex,excluderow);
	return result;
	
def compareDB_HTMLTableRow(elementID, rowIdx,datasourceID,rowIndex):
	result=playback.compareDB_HTMLTableRowValues(elementID, rowIdx,datasourceID,rowIndex);
	return result;
	
def compareDB_HTMLTableRowNM(tableprop, tablepropval, tableindex, rowIdx,datasourceID,rowIndex):
	result=playback.compareDB_HTMLTableRowValuesNM(tableprop, tablepropval, tableindex, rowIdx,datasourceID,rowIndex);
	return result;


def compareDB_HTMLTable(elementID, datasourceID,excluderow):
	result=playback.compareDB_HTMLTableAllValues(elementID, datasourceID,excluderow);
	return result;
	
def compareDB_HTMLTableNM(tableprop, tablepropval, tableindex, datasourceID,excluderow):
	result=playback.compareDB_HTMLTableAllValuesNM(tableprop, tablepropval, tableindex, datasourceID,excluderow);
	return result;

def compareCSV_HTMLTableColumn(elementID,columnIdx,datasourceID, columnIndex,excluderow):
	result=playback.compareCSV_HTMLTableColumnValues(elementID,columnIdx,datasourceID, columnIndex,excluderow);
	return result;	

def compareCSV_HTMLTableColumnNM(tableprop, tablepropval, tableindex,columnIdx,datasourceID, columnIndex,excluderow):
	result=playback.compareCSV_HTMLTableColumnValuesNM(tableprop, tablepropval, tableindex,columnIdx,datasourceID, columnIndex,excluderow);
	return result;	

def compareCSV_HTMLTableRow(elementID,rowIdx,datasourceID, rowIndex):
	result=playback.compareCSV_HTMLTableRowValues(elementID,rowIdx,datasourceID, rowIndex);
	return result;

def compareCSV_HTMLTableRowNM(tableprop, tablepropval, tableindex,rowIdx,datasourceID, rowIndex):
	result=playback.compareCSV_HTMLTableRowValuesNM(tableprop, tablepropval, tableindex,rowIdx,datasourceID, rowIndex);
	return result;

def compareCSV_HTMLTable(elementID, datasourceID,excluderow):
	result=playback.compareCSV_HTMLTableAllValues(elementID, datasourceID,excluderow);
	return result;

def compareCSV_HTMLTableNM(tableprop, tablepropval, tableindex, datasourceID,excluderow):
	result=playback.compareCSV_HTMLTableAllValuesNM(tableprop, tablepropval, tableindex, datasourceID,excluderow);
	return result;
	
def skipScriptExecution(scriptname):
	result=playback.skipScriptExecution(scriptname);
	return result;

def getScriptName():
	return playback.scriptName;

def terminateBrowser():
	return playback.terminateBrowser();

def setScriptThreshold(limit):
	return playback.setScriptThreshold(limit);

# Expert Mode Functions
def setWindowNM(parentTitle,windowTitle,windowName,winIndex,waittime,conString="eq,eq,eq"):
	return playback.setWindow(windowName,waittime,parentTitle,windowTitle,conString,winIndex);

def setHTMLPopupNM(parentTitle,windowTitle,windowName,winIndex,waittime,conString="eq,eq,eq"):
	return playback.setHTMLPopup(windowName,waittime,parentTitle,windowTitle,conString,winIndex);

def setDialogNM(parentTitle,windowTitle,windowName,winIndex,waittime,conString="eq,eq,eq"):
	return playback.setDialog(windowName,waittime,parentTitle,windowTitle,conString,winIndex);

def setDialogWindowNM(parentTitle,windowTitle,windowName,winIndex,waittime,conString="eq,eq,eq"):
	return playback.setDialogWindow(windowName,waittime,parentTitle,windowTitle,conString,winIndex);

def setAlertWindowNM(parentTitle,windowTitle,windowName,winIndex,waittime,contString="eq,eq,eq"):
	return playback.setAlertWindow(windowName,waittime,parentTitle,windowTitle,contString,winIndex);

def closeWindowNM(parentTitle,windowTitle,windowname,index,waittime,conString="eq,eq,eq"):
	return playback.closeWindow(parentTitle,windowTitle,windowname,index,waittime,conString);

def closeDialogNM(parentTitle,windowTitle,windowname,index,waittime,conString="eq,eq,eq"):
	return playback.closeDialog(parentTitle,windowTitle,windowname,index,waittime,conString);

def closeAlertWindowNM(parentTitle,windowTitle,windowname,index,waittime,conString="eq,eq,eq"):
	return playback.closeAlertWindow(parentTitle,windowTitle,windowname,index,waittime,conString);

