/* $Id: dtree.js,v 1.1.2.28 2009/10/14 15:32:46 srinivasar Exp $*/
/*--------------------------------------------------|

| dTree 2.05 | www.destroydrop.com/javascript/tree/ |

|---------------------------------------------------|

| Copyright (c) 2002-2003 Geir Landr               |

|                                                   |

| This script can be used freely as long as all     |

| copyright messages are intact.                    |

|                                                   |

| Updated: 17.04.2003                               |

|--------------------------------------------------*/

// Node object
function Node(id, pid, name, url, title, target, icon, iconOpen, open) {

	this.id = id;

	this.pid = pid;

	this.name = name;

	this.url = url;

	this.title = title;

	this.target = target;

	this.icon = icon;

	this.iconOpen = iconOpen;

	this._io = open || false;

	this._is = false;

	this._ls = false;

	this._hc = false;

	this._ai = 0;

	this._p;

};



// Tree object

function dTree(objName) {

	this.config = {

		target					: null,

		folderLinks			: true,

		useSelection		: true,

		useCookies			: true,

		useLines				: true,

		useIcons				: true,

		useStatusText		: false,

		closeSameLevel	: false,

		inOrder					: false

	}

	this.icon = {

		root				: '/framework/images/base.gif',

		folder			: '/framework/images/folder.gif',

		folderOpen	: '/framework/images/folderopen.gif',

		node				: '/framework/images/page.gif',

		empty				: '/framework/images/empty.gif',

		line				: '/framework/images/line.gif',

		join				: '/framework/images/join.gif',

		joinBottom	: '/framework/images/joinbottom.gif',

		plus				: '/framework/images/plus.gif',

		plusBottom	: '/framework/images/plusbottom.gif',

		minus				: '/framework/images/minus.gif',

		minusBottom	: '/framework/images/minusbottom.gif',

		nlPlus			: '/framework/images/nolines_plus.gif',

		nlMinus			: '/framework/images/nolines_minus.gif'

	};

	this.obj = objName;

	this.aNodes = [];

	this.aIndent = [];

	this.root = new Node(-1);

	this.selectedNode = null;

	this.selectedFound = false;

	this.completed = false;

};



// Adds a new node to the node array

dTree.prototype.add = function(id, pid, name, url, title, target, icon, iconOpen, open) {

	this.aNodes[this.aNodes.length] = new Node(id, pid, name, url, title, target, icon, iconOpen, open);

};



// Open/close all nodes

dTree.prototype.openAll = function() {

	this.oAll(true);

};

dTree.prototype.closeAll = function() {

	this.oAll(false);

};



// Outputs the tree to the page

dTree.prototype.toString = function() {

	var str = '<div class="dtree">\n';

	if (document.getElementById) {

		if (this.config.useCookies) this.selectedNode = this.getSelected();

		str += this.addNode(this.root);

	} else str += 'Browser not supported.';

	str += '</div>';

	if (!this.selectedFound) this.selectedNode = null;

	this.completed = true;

	return str;

};



// Creates the tree structure

dTree.prototype.addNode = function(pNode) {

	var str = '';

	var n=0;

	if (this.config.inOrder) n = pNode._ai;

	for (n; n<this.aNodes.length; n++) {

		if (this.aNodes[n].pid == pNode.id) {

			var cn = this.aNodes[n];

			cn._p = pNode;

			cn._ai = n;

			this.setCS(cn);

			if (!cn.target && this.config.target) cn.target = this.config.target;

			if (cn._hc && !cn._io && this.config.useCookies) cn._io = this.isOpen(cn.id);

			if (!this.config.folderLinks && cn._hc) cn.url = null;

			if (this.config.useSelection && cn.id == this.selectedNode && !this.selectedFound) {

					cn._is = true;

					this.selectedNode = n;

					this.selectedFound = true;

			}

			str += this.node(cn, n);

			if (cn._ls) break;

		}

	}

	return str;

};



// Creates the node icon, url and text

dTree.prototype.node = function(node, nodeId) {

	var str = '<div class="dTreeNode" >' + this.indent(node, nodeId);

	if (this.config.useIcons) {

		if (!node.icon) node.icon = (this.root.id == node.pid) ? this.icon.root : ((node._hc) ? this.icon.folder : this.icon.node);

		if (!node.iconOpen) node.iconOpen = (node._hc) ? this.icon.folderOpen : this.icon.node;

		if (this.root.id == node.pid) {

			node.icon = this.icon.root;

			node.iconOpen = this.icon.root;

		}

		str += '<img id="i' + this.obj + nodeId + '"oncontextmenu="if('+this.obj+'.rightClickselect(\''+node.url+'\',\''+node.name+'\',\''+node.pid+'\')){return showMenu(this,\'m2\',event,\''+node.id+'\',\''+node.pid+'\',\''+node.url+'\',\''+node.name+'\');}"  src="' + ((node._io) ? node.iconOpen : node.icon) + '" alt="" />';

	}

	if (node.url) {
		if(node.id!="Add New Load Test")
		{
			str += '<a id="s' + this.obj + nodeId + '"  oncontextmenu="if('+this.obj+'.rightClickselect(\''+node.url+'\',\''+node.name+'\',\''+node.pid+'\')){ return showMenu(this,\'m2\',event,\''+node.id+'\',\''+node.pid+'\',\''+node.url+'\',\''+node.name+'\');} " class="' + ((this.config.useSelection) ? ((node._is ? 'nodeSel' : 'node')) : 'node') + '" href="' + node.url + '"';
		}

		if (node.title) str += ' title="' + node.title + '"';

		if (node.target) str += ' target="' + node.target + '"';

		if (this.config.useStatusText) str += ' onmouseover="window.status=\'' + node.name + '\';return true;" onmouseout="window.status=\'\';return true;" ';

		if(node.id!="Add New Load Test")
		{
			if (this.config.useSelection && ((node._hc && this.config.folderLinks) || !node._hc))

				str += ' onclick="javascript: ' + this.obj + '.s(' + nodeId + '); "';
		}

		if(node.id=="Add New Load Test")
		{
			str += '<a style="cursor:pointer" id="s' + this.obj + nodeId+'" onclick="javascript:createNewLoad(\''+node.pid+'\');"';		
		}

		str += '>';

	}
	else if(node.pid="-1")
	{
			str += '<a href="javascript:dummy();" oncontextmenu="if('+this.obj+'.rightClickselect(\''+node.url+'\',\''+node.name+'\',\''+node.pid+'\')){ return showMenu(this,\'m2\',event,\''+node.id+'\',\''+node.pid+'\',\''+node.url+'\',\''+node.name+'\');} " disable=true  />';
	}

	else if ((!this.config.folderLinks || !node.url) && node._hc && node.pid != this.root.id)

		str += '<a href="javascript: ' + this.obj + '.o(' + nodeId + ');" oncontextmenu=" return showMenu(this,\'m2\',event,\''+node.id+'\',\''+node.pid+'\',\''+node.url+'\',\''+node.name+'\');" class="node">';

	str += node.name;

	if (node.url || ((!this.config.folderLinks || !node.url) && node._hc)) str += '</a>';

	str += '</div>';

	if (node._hc) {

		str += '<div id="d' + this.obj + nodeId + '" class="clip" style="display:' + ((this.root.id == node.pid || node._io) ? 'block' : 'none') + ';">';

		str += this.addNode(node);

		str += '</div>';

	}

	this.aIndent.pop();

	return str;

};

function dummy(){};
// Adds the empty and line icons

dTree.prototype.indent = function(node, nodeId) {

	var str = '';

	if (this.root.id != node.pid) {

		for (var n=0; n<this.aIndent.length; n++)

			str += '<img src="' + ( (this.aIndent[n] == 1 && this.config.useLines) ? this.icon.line : this.icon.empty ) + '" alt="" />';

		(node._ls) ? this.aIndent.push(0) : this.aIndent.push(1);

		if (node._hc) {

			str += '<a href="javascript: ' + this.obj + '.o(' + nodeId + ');"><img id="j' + this.obj + nodeId + '" src="';

			if (!this.config.useLines) str += (node._io) ? this.icon.nlMinus : this.icon.nlPlus;

			else str += ( (node._io) ? ((node._ls && this.config.useLines) ? this.icon.minusBottom : this.icon.minus) : ((node._ls && this.config.useLines) ? this.icon.plusBottom : this.icon.plus ) );

			str += '" alt="" /></a>';

		} else str += '<img src="' + ( (this.config.useLines) ? ((node._ls) ? this.icon.joinBottom : this.icon.join ) : this.icon.empty) + '" alt="" />';

	}

	return str;

};



// Checks if a node has any children and if it is the last sibling

dTree.prototype.setCS = function(node) {

	var lastId;

	for (var n=0; n<this.aNodes.length; n++) {

		if (this.aNodes[n].pid == node.id) node._hc = true;

		if (this.aNodes[n].pid == node.pid) lastId = this.aNodes[n].id;

	}

	if (lastId==node.id) node._ls = true;

};



// Returns the selected node

dTree.prototype.getSelected = function() {

	var sn = this.getCookie('cs' + this.obj);

	return (sn) ? sn : null;

};

dTree.prototype.getSelectedNodeName = function()
{
	var sn = this.getCookie('nn' + this.obj);

	return (sn) ? sn : null;
}

dTree.prototype.getSelectedNodeParentName = function()
{
	var sn = this.getCookie('pn' + this.obj);

	return (sn) ? sn : null;
}


// Highlights the selected node

dTree.prototype.s = function(id) {
	
	if(window.parent.recordMode==true)
	{
		n = document.getElementById("s" + this.obj + id);
		n.target="";
		n.href="#";
		alert("Please stop recording and then navigate ");
		return false;
	}
	if(window.parent.playMode=="true" || window.parent.playMode==true)
	{
		n = document.getElementById("s" + this.obj + id);
		n.target="";
		n.href="#";
		alert("Please stop the play and then navigate ");
		return false;
	}
	if(window.parent.recordMode=="false" || window.parent.recordMode==false)
	{
		//alert("inside record mode falase "+parent.document.getElementById("editor").l);
		var onLoadContent;
		var content;
		if(window.parent.editor.EditH)
		{
			con=window.parent.editor.EditH.getContent();
			content=window.parent.editor.EditH.h2t(con);
			onLoadContent=window.parent.editor.contentOnLoad;
			//alert("Content in dree"+cont1);
			//alert("Content in dree"+window.parent.editor.contentOnLoad);
		}
		try
		{
			if(window.parent.parent.parent.document.getElementById("sug-func1").style.display == "block")
			{
				window.parent.parent.parent.document.getElementById("sug-func1").style.display = "none";
			}

			if(window.parent.parent.parent.document.getElementById("syntaxdiv").style.display == "block")
			{
				window.parent.parent.parent.document.getElementById("syntaxdiv").style.display = "none";
			}
		}
		catch(e){}

		if(content!=onLoadContent)
		{	
			scriptname=window.parent.editor.document.getElementById("script").value;
			conf=confirm("Save changes to script "+scriptname+"?")
			if(conf)
			{
				result = window.parent.editor.savescript(false);
			}

		}
	}


	parent.loadingScreen("Loading....");
	if (!this.config.useSelection) return;

	var cn = this.aNodes[id];


	if (cn._hc && !this.config.folderLinks) return;

	if (this.selectedNode != id) {

		if (this.selectedNode || this.selectedNode==0) {

			eOld = document.getElementById("s" + this.obj + this.selectedNode);
			if(eOld)
			{
				eOld.className = "node";
			}

		}
		eNew = document.getElementById("s" + this.obj + id);

		eNew.className = "nodeSel";

		this.selectedNode = id;
		if (this.config.useCookies) {
			this.setCookie('cs' + this.obj, cn.id);
			this.setCookie('nn' + this.obj, cn.name);
			this.setCookie('pn' + this.obj, cn.pid);

		}

	}
	if(cn.pid=="Suites")
	{
		suiteLevel="true";
		selectedSuiteNode=cn.name;
	}
	else
	{
		suiteLevel="false";
		selectedSuiteNode="";
	}
};

//return name of the node - arg=> id
dTree.prototype.getName = function(id)
{
	for (var n=0; n<this.aNodes.length; n++)
	{
			if(this.aNodes[n].id == id)
			{
				return this.aNodes[n].name;
			}
	}
	return "";

};

dTree.prototype.searchFor = function(txt)
{
	var nodesArr = new Array();
	var ii = 0;
	for (var n=0; n<this.aNodes.length; n++)
	{
		
			if(this.aNodes[n].name.indexOf(txt)>=0)
			{
				nodesArr[ii++]=this.aNodes[n];
			}
	}
	return nodesArr;

};

//return ParentId of the node - arg=> id
dTree.prototype.getParentId = function(id)
{
	for (var n=0; n<this.aNodes.length; n++)
	{
			if(this.aNodes[n].id == id)
			{
				return this.aNodes[n].pid;
			}
	}
	return "";

};


//return id of the node - arg=> name of the node

dTree.prototype.getIdForName = function(name)
{

	for (var n=0; n<this.aNodes.length; n++)
	{
			if(this.aNodes[n].name == name)
			{
				return this.aNodes[n].id;
			}
	}
	return "";

};

dTree.prototype.getCorrectIdForName = function(name,pid)
{

   for (var n=0; n<this.aNodes.length; n++)
   {
           if(this.aNodes[n].name == name)
           {
           //alert(this.aNodes[n].pid);
           //alert("MMM"+pid);
           if(this.aNodes[n].name == name && this.aNodes[n].pid == pid)
           {
               return this.aNodes[n].id;
           }
           }
   }
   return "";

};

dTree.prototype.getNodeForNameAndPID = function(name,parentId)
{
	for (var n=0; n<this.aNodes.length; n++)
	{
			if(this.aNodes[n].name == name && this.aNodes[n].pid == parentId)
			{
				return this.aNodes[n];
			}
	}
	return null;

};


//return node - arg=> id of the node Note :; Return value is not a node - element <a></a>

dTree.prototype.getNode = function(id)
{

	for (var n=0; n<this.aNodes.length; n++)
	{

			if(this.aNodes[n].id == id)
			{
				nod = document.getElementById("s" + this.obj + n);
				return nod;
			}
	}
	return null;

};

dTree.prototype.isNodeExist = function(nodeName,parentNodeName)
{
	for (var n=0; n<this.aNodes.length; n++)
	{
			if(this.aNodes[n].name == nodeName && this.aNodes[n].pid == parentNodeName)
			{
				return true;
			}
	}
	return false;

}

dTree.prototype.rightClickselect = function(node_url,name,pidofnode)
{
	//alert(node_url.substring(50));
if(window.parent.recordMode=="true" || window.parent.recordMode==true)
	{
		alert("Please stop the record and then navigate ");
		return false;
	}
 if(window.parent.playMode=="true" || window.parent.playMode==true)
	{
		alert("Please stop the play and then navigate ");
		return false;
	}
	var suitename ="";
	var scriptname="";
	var scriptpath="";
	if(node_url.indexOf("suitename")>0)
	{
		suitename= node_url.substring(node_url.indexOf("suitename=")+10);
		if(suitename.indexOf("&")>0)
		{
			suitename = suitename.substring(0,suitename.indexOf("&")); 
		}
	}
	if(node_url.indexOf("suitelevel=true")>0 || node_url.indexOf("SuiteLevelScreen.jsp")>0)
	{
		right_click_suitelevel=true;
	}
	else
	{
		right_click_suitelevel=false;
	}
	
	if(node_url.indexOf("ltname=")>0)
	{
		scriptname=node_url.substring(node_url.indexOf("ltname=")+7);
		if(scriptname.indexOf("&")>0)
		{
			scriptname = scriptname.substring(0,scriptname.indexOf("&")); 
		}
	}
	else if(node_url.indexOf("servicename=")>0 || node_url.indexOf("serviceName=")>0)
	{
		scriptname=node_url.substring(node_url.indexOf("scriptname=")+11);
		if(scriptname.indexOf("&")>0)
		{
			scriptname = scriptname.substring(0,scriptname.indexOf("&")); 
		}
		scriptpath=node_url.substring(node_url.indexOf("scriptpath=")+11);
		if(scriptpath.indexOf("&")>0)
		{
			scriptpath = scriptpath.substring(0,scriptpath.indexOf("&")); 
		}
		servicename=node_url.substring(node_url.indexOf("servicename=")+12);
		if(servicename.indexOf("&")>0)
		{
			servicename = servicename.substring(0,servicename.indexOf("&")); 
		}
		servicepath=node_url.substring(node_url.indexOf("servicepath=")+12);
		if(servicepath.indexOf("&")>0)
		{
			servicepath = servicepath.substring(0,servicepath.indexOf("&")); 
		}
		else
		{
			servicepath="";
		}

		try
		{
			document.getElementById("rightclick_servicename").value=servicename;
		}
		catch(e){}
		try
		{
			document.getElementById("rightclick_servicepath").value=servicepath;
		}
		catch(e){}

	}
	else if(node_url.indexOf("scriptname=")>0)
	{
		scriptname=node_url.substring(node_url.indexOf("scriptname=")+11);
		if(scriptname.indexOf("&")>0)
		{
			scriptname = scriptname.substring(0,scriptname.indexOf("&")); 
		}
		scriptpath=node_url.substring(node_url.indexOf("scriptpath=")+11);
		if(scriptpath.indexOf("&")>0)
		{
			scriptpath = scriptpath.substring(0,scriptpath.indexOf("&")); 
		}


	}
	
	//alert(scriptname);
	right_click_project =suitename;
	right_click_script=scriptname;
	right_click_scriptpath=scriptpath;
	pidofnode = replaceAll(pidofnode,"\\","//");
	pidofnode = replaceAll(pidofnode,"//","\\\\");
	right_click_pid=pidofnode;
	try
	{
		document.getElementById("rightclick_suitename").value=suitename;	
	}
	catch(e)	{	}
	try
	{
		document.getElementById("rightclick_script").value=scriptname;	
	}	catch(e)	{	}
	try
	{
		document.getElementById("rightclick_scriptpath").value=scriptpath;	
	}
	catch(e)	{}

	//if(node_url.indexOf("webload/")<0 && node_url.indexOf("webfunctional/")<0 && node_url.indexOf("wsfunctional/")<0)
	//{
		for (var n=0; n<this.aNodes.length; n++)
		{
			if (this.aNodes[n].pid != this.root.id)
			{
				var cur = this.aNodes[n].pid;
			//	var cur = replaceAll(this.aNodes[n].pid,"\\\\","\\");
				if(this.aNodes[n].name == name && cur==pidofnode)
				{
					this.select(this.aNodes[n].name,this.aNodes[n].pid);
					break;
				}
			}

		}
//	}
	return true;

}
//setSelect

dTree.prototype.select = function(nodeName,parentNodeName)
{
	right_click_project ="";
	right_click_script="";
	right_click_scriptpath="";

	if(window.parent.recordMode=="true" || window.parent.recordMode==true)
	{
//		alert("Please stop recording and then navigate ");
		return false;
	}
else if(window.parent.playMode=="true" || window.parent.playMode==true)
	{
		return false;
	}
///For refreshing the tree in WF only
	try
	{
		if(blockClickEvent)
		{
			if(blockClickEvent=="true")
			{
				blockClickEvent="false";
				return false;
			}
		}
	}
	catch(e)
	{
	}



	for (var n=0; n<this.aNodes.length; n++)
	{
		if (this.aNodes[n].pid != this.root.id)
		{
		//	alert(this.aNodes[n].name +" == "+ nodeName);
			if(this.aNodes[n].name == nodeName && this.aNodes[n].pid == parentNodeName)
			{
				a = document.getElementById("s" + this.obj + n);
				a.scrollIntoView();
				init();
				if(isIE==true)
				{
					a.click();
				}
				else
				{

					var geckoResult = /^Mozilla\/5\.0 .*Gecko\/(\d{8}).*$/.exec(navigator.userAgent);
					var geckoVersion = geckoResult == null ? null : geckoResult[1];
					var needsProgrammaticClick = (geckoVersion > '20041025');
					///This is done for Firefox and its higher version , because Click event is restricted in Mozilla 1.7, firefox1.0 and their higher version...
    				if (needsProgrammaticClick)
					{
						this.s(n);
						parent.document.getElementById("editor").src=a.href;
					}
					else
					{

						var e = document.createEvent('MouseEvents');
						e.initMouseEvent('click',              /* Event type */
								true,                 /* Can bubble */
								true,                 /* Cancelable */
								document.defaultView, /* View */
									1,                    /* Mouse clicks */
								0,                    /* Screen x */
								0,                    /* Screen y */
								0,                    /* Client x */
								0,                    /* Client y */
								false,                /* Ctrl */
								false,                /* Alt */
								false,                /* Shift */
								false,                /* Meta */
								0,                    /* Button */
								null);                /* Related target */

						a.dispatchEvent(e);
					}
				}
			}
		}
	}

};

dTree.prototype.searchSelect = function(nodeName,parentNodeName,prevNodeName,prevParentNodeName)
{
	var selNode = document.getElementById("s" + this.obj + this.selectedNode);
	for (var n=0; n<this.aNodes.length; n++)
	{
		if (this.aNodes[n].pid != this.root.id)
		{
		//	alert(this.aNodes[n].name +" == "+ nodeName);
			
			if(this.aNodes[n].name == nodeName && this.aNodes[n].pid == parentNodeName)
			{
				a = document.getElementById("s" + this.obj + n);
				a.className ="searchresult" ;
				a.scrollIntoView();
			}
			if(this.aNodes[n].name == prevNodeName && this.aNodes[n].pid == prevParentNodeName)
			{
				a = document.getElementById("s" + this.obj + n);
				if(selNode == a)
				{
					a.className="nodeSel";
				}
				else
				{
					a.className ="node" ;
				}
			}
		}
	}

};

// Toggle Open or close

dTree.prototype.o = function(id) {

	var cn = this.aNodes[id];

	this.nodeStatus(!cn._io, id, cn._ls);

	cn._io = !cn._io;

	if (this.config.closeSameLevel) this.closeLevel(cn);

	//if (this.config.useCookies) this.updateCookie();

};



// Open or close all nodes

dTree.prototype.oAll = function(status) {

	for (var n=0; n<this.aNodes.length; n++) {

		if (this.aNodes[n]._hc && this.aNodes[n].pid != this.root.id) {

			this.nodeStatus(status, n, this.aNodes[n]._ls)

			this.aNodes[n]._io = status;

		}

	}

	//if (this.config.useCookies) this.updateCookie();

};



// Opens the tree to a specific node

dTree.prototype.openTo = function(nId, bSelect, bFirst) {

	if (!bFirst) {

		for (var n=0; n<this.aNodes.length; n++) {

			if (this.aNodes[n].id == nId) {

				nId=n;

				break;

			}

		}

	}

	var cn=this.aNodes[nId];

	if (cn.pid==this.root.id || !cn._p) return;

	cn._io = true;

	cn._is = bSelect;

	if (this.completed && cn._hc) this.nodeStatus(true, cn._ai, cn._ls);

	if (this.completed && bSelect) this.s(cn._ai);

	else if (bSelect) this._sn=cn._ai;

	this.openTo(cn._p._ai, false, true);

};



// Closes all nodes on the same level as certain node

dTree.prototype.closeLevel = function(node) {

	for (var n=0; n<this.aNodes.length; n++) {

		if (this.aNodes[n].pid == node.pid && this.aNodes[n].id != node.id && this.aNodes[n]._hc) {

			this.nodeStatus(false, n, this.aNodes[n]._ls);

			this.aNodes[n]._io = false;

			this.closeAllChildren(this.aNodes[n]);

		}

	}

}



// Closes all children of a node

dTree.prototype.closeAllChildren = function(node) {

	for (var n=0; n<this.aNodes.length; n++) {

		if (this.aNodes[n].pid == node.id && this.aNodes[n]._hc) {

			if (this.aNodes[n]._io) this.nodeStatus(false, n, this.aNodes[n]._ls);

			this.aNodes[n]._io = false;

			this.closeAllChildren(this.aNodes[n]);

		}

	}

}



// Change the status of a node(open or closed)

dTree.prototype.nodeStatus = function(status, id, bottom) {
	eDiv	= document.getElementById('d' + this.obj + id);

	eJoin	= document.getElementById('j' + this.obj + id);

	if (this.config.useIcons) {

		eIcon	= document.getElementById('i' + this.obj + id);

		eIcon.src = (status) ? this.aNodes[id].iconOpen : this.aNodes[id].icon;

	}

	eJoin.src = (this.config.useLines)?

	((status)?((bottom)?this.icon.minusBottom:this.icon.minus):((bottom)?this.icon.plusBottom:this.icon.plus)):

	((status)?this.icon.nlMinus:this.icon.nlPlus);

	eDiv.style.display = (status) ? 'block': 'none';

};





// [Cookie] Clears a cookie

dTree.prototype.clearCookie = function() {

	var now = new Date();

	var yesterday = new Date(now.getTime() - 1000 * 60 * 60 * 24);

	this.setCookie('co'+this.obj, 'cookieValue', yesterday);

	this.setCookie('cs'+this.obj, 'cookieValue', yesterday);

	this.setCookie('nn'+this.obj, 'cookieValue', yesterday);

	this.setCookie('pn'+this.obj, 'cookieValue', yesterday);

};



// [Cookie] Sets value in a cookie

dTree.prototype.setCookie = function(cookieName, cookieValue, expires, path, domain, secure) {

	setCookie(cookieName,escape(cookieValue),"/");

	//document.cookie =

	//	escape(cookieName) + '=' + escape(cookieValue);

		//+ (expires ? '; expires=' + expires.toGMTString() : '')

		//+ (path ? '; path=' + path : '')

		//+ (domain ? '; domain=' + domain : '')

		//+ (secure ? '; secure' : '');

};



// [Cookie] Gets a value from a cookie

dTree.prototype.getCookie = function(cookieName) {

	var cookieValue = '';

	cookieValue = unescape(getCookie(cookieName));
//	var posName = document.cookie.indexOf(escape(cookieName) + '=');

//	if (posName != -1) {

//		var posValue = posName + (escape(cookieName) + '=').length;

//		var endPos = document.cookie.indexOf(';', posValue);

//		if (endPos != -1) cookieValue = unescape(document.cookie.substring(posValue, endPos));

//		else cookieValue = unescape(document.cookie.substring(posValue));

//	}

	return (cookieValue);

};



// [Cookie] Returns ids of open nodes as a string

dTree.prototype.updateCookie = function() {

	var str = '';

	for (var n=0; n<this.aNodes.length; n++) {

		if (this.aNodes[n]._io && this.aNodes[n].pid != this.root.id) {

			if (str) str += '.';

			str += this.aNodes[n].id;

		}

	}

	this.setCookie('co' + this.obj, str);

};



// [Cookie] Checks if a node id is in a cookie

dTree.prototype.isOpen = function(id) {

	var aOpen = this.getCookie('co' + this.obj).split('.');

	for (var n=0; n<aOpen.length; n++)

		if (aOpen[n] == id) return true;

	return false;

};

function replaceAll(str,toBeReplace,replaceStr)
{
	while(str.indexOf(toBeReplace)>=0)
	{
		str = str.replace(toBeReplace,replaceStr);
	}
	return str;
}

// If Push and pop is not implemented by the browser

if (!Array.prototype.push) {

	Array.prototype.push = function array_push() {

		for(var i=0;i<arguments.length;i++)

			this[this.length]=arguments[i];

		return this.length;

	}

};

if (!Array.prototype.pop) {

	Array.prototype.pop = function array_pop() {

		lastElement = this[this.length-1];

		this.length = Math.max(this.length-1,0);

		return lastElement;

	}

};

