<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
	extension-element-prefixes="xalan"> 
	<xsl:output method="html" version="4.0" encoding="UTF-8" indent="yes"/>
	<xsl:variable name="scriptDetails" select="/ELEMENT-MAPPING/WINDOW"/>
	<xsl:template match="/">
		<xalan:write select="concat($repdir,'/',$scriptNameWithMod,'/',$scriptName,'_pageprop.html')">
			<xsl:variable name="modnameforppreport">
				<xsl:choose>
					<xsl:when test="contains($scriptNameWithMod,'/')">
						<xsl:value-of select="substring-before($scriptNameWithMod,'/')" />
					</xsl:when>
					<xsl:otherwise>webscripts</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="suitenameforpageprop" select="/ELEMENT-MAPPING/@name" />	
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
						<![CDATA[
<style type="text/css">
a:link{ color: #000000; text-decoration: underline;}
a:visited{ color: #000000; text-decoration: underline;}
a:active{ color: #000000; text-decoration: underline; }
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	function MM_openBrWindow(theURL,winName,features) { //v2.0
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}
		var d = new Date();
	   var dateStr = d.toGMTString();


	  window.open(theURL+".html?datestring="+dateStr,winName,features);
}
function showPage(url)
{
	var d = new Date();
	var dateStr = d.toGMTString();
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

}
function showModPage(url,divid)
{
	window.parent.document.getElementById("main").src=url+"?divtoopen="+divid;
}

function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}
function invokeSummaryLeftReport()
{
	window.parent.frames[0].hideOtherDiv();
	window.parent.frames[0].changeiconnotifier();
}
</script>
					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Page Properties Report</title> 
				</head>
				<body onload="checkForPrint();" bgcolor="#FFFFFF" text="#000000">
					<table cellspacing="0" cellpadding="0" align="center" border="0" width="99%">
  <tr>
	  <td height="30" colspan="2" class="bodytext"><a href="javascript:showPage('scriptsummary.html');" onclick="invokeSummaryLeftReport();">Summary Report</a> &gt; <a href="javascript:showPage('scriptsummary.html');" onclick="invokeSummaryLeftReport();"> <xsl:value-of select="/ELEMENT-MAPPING/@suite" /> </a> &gt; <a href="javascript:showModPage('{concat($modnameforppreport,'.html')}','{concat($modnameforppreport,'_div')}')"> <xsl:value-of select="$modnameforppreport" /> </a> &gt; <a href="#"> <xsl:value-of select="$scriptName"/> </a> &gt; Page Property Report</td>
  </tr>
  <tr bgcolor="#ffffff">
    <td width="23%" class="reporth3">Page Property  Report</td>
	<td id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('{concat($scriptName,'_pageprop')}','PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
  </tr>
  <tr>
	  <td height="1" colspan="3"><span class="reporthline"><img height="1" width="1" src="/framework/images/spacer.gif"></img></span></td>
  </tr>
  <tr>
    <td height="30" colspan="2" class="reporth2">Page Property Report shows the properties of the executed page, such as, Window Title, Window Name, Status, Response Time, URL, etc,.</td>
  </tr>
</table>

				<br></br><br></br>
				  <table width="99%" align="center" cellpadding="0" cellspacing="0" border="0">
				     <tr>
					<td>
						<xsl:for-each select="$scriptDetails">
						<xsl:variable name="keyval" select="@name"/>
						<xsl:variable name="windowtitle" select="@windowtitle"/>
						<xsl:variable name="windowname" select="@windowname"/>
						<xsl:variable name="parenttitle" select="@parenttitle"/>
						<xsl:variable name="originURL" select="@originURL"/>
						<xsl:variable name="url" select="@url"/>
						<xsl:variable name="modifieddate" select="@modifieddate"/>
						<xsl:variable name="status" select="@status"/>
						<xsl:variable name="framecount" select="@framecount"/>
						<xsl:variable name="response_time" select="@response_time"/>
					  	<table width="100%" border="0" align="center" cellpadding="5" cellspacing="1" class="reporttablebg">
					          <tr> 
					            <th width="100" align="left" nowrap="nowrap" class="thstyle">Window Title</th>
					            <td colspan="3" align="left" bgcolor="#ffffff" class="tdstyle"><xsl:value-of select="$windowtitle"/></td>
					          </tr>
					          <tr> 
					            <th width="100" align="left" nowrap="nowrap" class="thstyle">Window Name</th>
					            <td colspan="3" align="left" bgcolor="#ffffff" class="tdstyle"><xsl:value-of select="$windowname"/></td>
					          </tr>
					          <tr> 
					            <th width="100" align="left" nowrap="nowrap" class="thstyle">Parent Title</th>
					            <td colspan="3" align="left" bgcolor="#ffffff" class="tdstyle"><xsl:value-of select="$parenttitle"/></td>
					          </tr>
					          <tr> 
					            <th width="100" align="left" nowrap="nowrap" class="thstyle">Origin URL</th>
								<td colspan="3" align="left" bgcolor="#ffffff" class="tdstyle">
									<xsl:choose>
										<xsl:when test="$originURL='NONE'">
											<xsl:value-of select="$originURL"/>
										</xsl:when>
										<xsl:otherwise>
											<a href="{concat('',$originURL)}"><xsl:value-of select="$originURL"/></a>
										</xsl:otherwise>
									</xsl:choose>
								</td>

					          </tr>
					          <tr> 
					            <th width="100" align="left" nowrap="nowrap" class="thstyle">URL</th>
								<td colspan="3" align="left" bgcolor="#ffffff" class="tdstyle"><a href="{concat('',$url)}"><xsl:value-of select="$url"/></a></td>
					          </tr>

					          <tr> 
					          <td colspan="4" align="left" bgcolor="#ffffff" class="tdstyle">
					  	<table border="0" align="left" cellpadding="5" cellspacing="1" class="reporttablebg" width="100%">

					                <tr bgcolor="#ffffff"> 
					                  <th nowrap="nowrap" class="thstyle" width="100">Status</th>
					                  <th nowrap="nowrap" class="thstyle">Response Time (ms)</th>
					                  <th nowrap="nowrap" class="thstyle">Modified Date</th>
					                  <th nowrap="nowrap" class="thstyle">Frame Count</th>
					                </tr>
					                <tr bgcolor="#ffffff"> 
					                  <td align="center" class="tdstyle" width="100"><xsl:value-of select="$status"/></td>
					                  <td align="center" class="tdstyle"><xsl:value-of select="$response_time"/></td>
					                  <td align="center" class="tdstyle"><xsl:value-of select="$modifieddate"/></td>
					                  <td align="center" class="tdstyle"><xsl:value-of select="$framecount"/></td>
					                </tr>
					              </table>

						</td>
				                </tr>
				              </table>					              <br></br>
      						</xsl:for-each>
					    </td>
					</tr>
				</table>
				</body>
			</html>
		</xalan:write>
	</xsl:template>
</xsl:stylesheet>

