<?xml version="1.0"?>
<xsl:stylesheet xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:common="http://exslt.org/common" xmlns:set="http://exslt.org/sets" version="1.0" extension-element-prefixes="xalan"> 
	<xsl:output method="html" version="4.0" encoding="UTF-8" indent="yes"/>
	<xsl:variable name="scriptDetails" select="/validation_report/report/script"/>
	<xsl:variable name="statusreport" select="/validation_report/status/name" />
	<xsl:variable name="severityreport" select="/validation_report/configuredseverities/severity" />
	<!-- Variable related with testcases -->
	<xsl:variable name="tcreportDetails" select="/validation_report/report/script/testcases/case" />
	<xsl:variable name="uniquemodules" select="/validation_report/moduleslist/module" />
	<xsl:variable name="uniquevalues" select="set:distinct(/validation_report/report/script/@namewithmod)" />
	<xsl:variable name="tcasestatus" select="/validation_report/tcstatus/status" />
	<xsl:variable name="totalcount" select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])"/>
	<xsl:variable name="tcasecount" select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" />
	<!-- Variable related with testcases -->
	<xsl:template name="getsubstringval">
		<xsl:param name="argmodule" />
			<xsl:value-of select="substring-before($argmodule,'/')" />
		</xsl:template>


<xsl:template name="reverse">
	<xsl:param name="string"/>
	<xsl:value-of select="substring($string, string-length($string))"/>
	<xsl:if test="string-length($string) > 1">
		<xsl:call-template name="reverse">
			<xsl:with-param name="string"
select="substring($string, 1, (string-length($string)-1))"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>

<xsl:template name="rindex">
	<xsl:param name="string"/>
	<xsl:param name="substring"/>
	<xsl:choose>
		<xsl:when test="contains($string,$substring)">
			<xsl:variable name="rstring">
				<xsl:call-template name="reverse">
					<xsl:with-param name="string"
select="$string"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="rsubstring">
				<xsl:call-template name="reverse">
					<xsl:with-param name="string"
select="$substring"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="tmpVal" select="string-length($string) -
(string-length(substring-before($rstring,$rsubstring)) +
string-length($rsubstring)) + 2"/>
			<xsl:value-of select="substring($string,number($tmpVal))" />
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$string"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>
		









	<xsl:template match="/">

		<xsl:for-each select="/validation_report/moduleslist/module">
			<xsl:variable name="modnames" select="@name" />
			<xalan:write select="concat($repdir,'/',$modnames,'.html')">
				<html>
					<head>
					<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
a:link{ color: #000000; text-decoration: underline;}
a:visited{ color: #000000; text-decoration: underline;}
a:active{ color: #000000; text-decoration: underline; }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thstyle a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}

.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle a{ text-decoration: underline; color:#000000; }
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
function MM_openBrWindow(theURL,winName,features) { //v2.0
	theURL = theURL.substring(0,theURL.length-1);
	winurl = window.document.URL;
		divtoopenup = winurl.substring(winurl.indexOf("=")+1);
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?divtoopen="+divtoopenup,winName,features);
  }
   
  function showPage(url)
	{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

	}
  function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}


function loadDiv()
{
	urlvalue = window.document.URL;
	divtoopen = urlvalue.substring(urlvalue.indexOf("=")+1,urlvalue.length);
	showDiv(divtoopen);
}

function showDiv(elem)
{
hideAllDiv();
divtoshow = document.getElementById(elem);
eval("divtoshow.style.display='block';");
}

	function hideAllDiv()
	{
		divArr = document.getElementsByTagName("DIV");
		for(var j=0;j<divArr.length;j++)
		{
			divid = divArr[j].id;
			divtohide = document.getElementById(divid);
			eval("divtohide.style.display='none';");
		}
	}
function showReportPage(elem)
{
	window.location.href=elem;
}

function constructModFromTR(elem)
{
	try
	{
		alert(elem.innerText);
		modname = elem.innerText;
		window.parent.showScriptFromTR(modname);	
	}
	catch(e) {}	
}
function invokeSummaryLeftReport()
{
	window.parent.frames[0].hideOtherDiv();
	window.parent.frames[0].changeiconnotifier();
}
  </script>

					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Script Summary</title>
				</head>
					<body onload="loadDiv();checkForPrint();">
						
						<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0">
							<tr valign="top">
								<td height="25" colspan="2" class="tdlinkslevel"><a href="javascript:showPage('scriptsummary.html');" onclick="javascript:invokeSummaryLeftReport();">Summary Report </a>&gt; <a href="javascript:showPage('scriptsummary.html');" onclick="javascript:invokeSummaryLeftReport();"> <xsl:value-of select="/validation_report/testconfigdetails/@suitename" /> </a> &gt;  <xsl:value-of select="$modnames" />  </td>
							</tr>

							<!--Going to include the TestCase summary Report here -->
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
										<tr>
											<td width="30%" class="reporth3">TestCase Summary Report</td>
											<td width="70%" id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('{concat($modnames,'_')}', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>

							<tr>
								<td height="25"  class="reporth2">The Summary Report shows the summary view of all the TestCases and Checkpoint executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2">
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>
							</tr>
						</table>

						<table align="center" width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
							<tr>
								<td>
									<table width="100%" border="0" cellpadding="5" cellspacing="1">
										<tr class="thstyle1" align="center">
											<th class="thstyle" width="10%">Module Name</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Failed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Passed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Pending</th>
											<th class="thstyle" width="6%">Total</th>
										</tr>
										<tr class="thstyle1" align="center">
											<th class="tdstyle"/>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle"/>
										</tr>

										

								<xsl:for-each select="/validation_report/report/script/testcases/case">
									<xsl:variable name="moduleval" select="@scriptid"/>
									<xsl:variable name="modulename" select="substring-before($moduleval,'/')" />
								</xsl:for-each>

								<!--<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:choose>
											<xsl:when test="not(contains(@scriptid,'/'))">
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/>-webscripts </td>
												</tr>
											</xsl:when>
											<xsl:otherwise>
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/> </td> 
												</tr>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:for-each> -->

									<xsl:choose>
										<xsl:when test="$tcasecount=0">
											<tr>
												<td colspan="14" align="center" class="subthstyle">No TestCase Configured</td>
											</tr>
										</xsl:when>
										<xsl:otherwise>
											
										

									<xsl:for-each select="$uniquemodules">
										<xsl:variable name="modname" select="@name" />
										<xsl:variable name="temp" select="position() mod 2"/>
										<tr class="{concat('tdstyle',$temp)}" align="center">
											<td align="left" width="10%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"><xsl:value-of select="@name"/></a></td>
											<xsl:for-each select="$tcasestatus">
												<xsl:variable name="statval" select="@name"/>
												<xsl:for-each select="$severityreport">
													<xsl:variable name="sevname" select="@name"/>

													<xsl:if test="$statval='PASSED' or $statval='FAILED'">
													
														<xsl:if test="$modname!='webscripts'">
															<xsl:variable name="idref" select="concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)"/>
																<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and (substring-before(@scriptid,'/')=$modname)])"/> </a> </td>
														</xsl:if>
														
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and not(contains(@scriptid,'/'))])"/> </a> </td>
														</xsl:if>
														
													
													</xsl:if>
													
													<xsl:if test="$statval='PENDING'">
														
														<xsl:if test="$modname!='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and (substring-before(@scriptid,'/')=$modname) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and not(contains(@scriptid,'/')) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
													</xsl:if>
												
												</xsl:for-each>
											</xsl:for-each>

											<xsl:if test="$modname!='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/'))=$modname])"/> </a> </td>
											</xsl:if>
											<xsl:if test="$modname='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[not(contains(@scriptid,'/'))])"/> </a> </td>
											</xsl:if>
											
										</tr>
									</xsl:for-each>

									<tr class="thstyle1" align="center">
										<td  width="10%" class="thstyle" align="left">Total</td>
										<xsl:for-each select="$tcasestatus">
											<xsl:variable name="tcstatusval" select="@name" />
											<xsl:for-each select="$severityreport">
												<xsl:variable name="severityval" select="@name" />
												<xsl:variable name="statcount">
													<xsl:choose>
														<xsl:when test="$tcstatusval='PENDING'">
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" />
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$tcstatusval and @severity=$severityval])" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<!--<xsl:if test="@status='PASSED' or @status='FAILED'">-->
													<td width="7%" class="tdstyle"> <a href="#" onclick="showReportPage('{concat('./',$tcstatusval,'.html?divtoopen=',$tcstatusval,'_',$severityval)}');"> <xsl:value-of select="$statcount" /> </a></td>
													<!--</xsl:if>
												<xsl:if test="@status='PENDING'">
													<td width="7%" class="tdstyle"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" /> </td>
												</xsl:if>-->
											</xsl:for-each>
										</xsl:for-each>
										<td width="6%" class="tdstyle"> <a href="#" onclick="showReportPage('./total.html');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" /> </a> </td>
									</tr>


									</xsl:otherwise>
									</xsl:choose>

									
									</table>


								</td>
							</tr>
						</table>
						<br/>
						<br/>
						<br/>


						<!-- TestCase Summary Report included -->

						<div id="{concat($modnames,'_div')}" style="display:none;">
							<table border='0' cellspacing='0' cellpadding='0' class='' width='100%'>
								<tr>
									<td class='subthstyle'><strong> Summary Report for <xsl:value-of select="$modnames" /> </strong> </td>
								</tr>
							</table>
						<table border="0" cellspacing="0" cellpadding="0" class="reporttablebg" width="100%">
							<tr>
								<td>
									<table border='0' cellspacing='1' cellpadding='5' class='' width="100%">
										<tr class="thstyle1" align="center">
											<th class="thstyle"> TestCase ID </th>
											<th class="thstyle"> Script Name </th>
											<th class="thstyle"> Severity </th>
											<th class="thstyle"> Status </th>
											<th class="thstyle"> Debug Information </th>
											<th class="thstyle"> Expected Values </th>
											<th class="thstyle"> Actual Values </th>
											<th class="thstyle"> Remarks </th>
										</tr>
										<xsl:for-each select="/validation_report/report/script/testcases/case">
											<xsl:variable name="modname">
												<xsl:choose>
													<xsl:when test="contains(@scriptid,'/')">
														<xsl:value-of select="substring-before(@scriptid,'/')" />
													</xsl:when>
													<xsl:otherwise>webscripts</xsl:otherwise>
												</xsl:choose>
											</xsl:variable>




											<xsl:if test="$modname=$modnames">
												<xsl:variable name="temp" select="position() mod 2" />
												<xsl:variable name="tcid" select="@id" />
												<xsl:variable name="scriptname">
													<xsl:choose>
														<xsl:when test="contains(@scriptid,'/')">
															<!--<xsl:value-of select="substring-after(@scriptid,'/')" />-->
															<xsl:call-template name="rindex">
																<xsl:with-param name="string" select="@scriptid"/>
																<xsl:with-param name="substring" select="'/'"/>
															</xsl:call-template>
															
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="@scriptid" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<xsl:variable name="severity" select="@severity" />
												<xsl:variable name="status" select="@status" />
												<xsl:variable name="debuginfo" select="@debuginfo" />
												<xsl:variable name="expectedvalue" select="@expectedvalue" />
												<xsl:variable name="actualvalue" select="@actualvalue" />
												<xsl:variable name="loginfo" select="@logmessage" />
												<tr align="center" class="{concat('tdstyle',$temp)}">
													<td class="tdstyle" align="left"> <xsl:value-of select="$tcid" /> </td>
													<td class="tdstyle"> <xsl:value-of select="$scriptname" /> </td>
													<xsl:if test="@severity='ShowStopper'">
															<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
													</xsl:if>
													<xsl:if test="@severity='Critical'">
														<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
													</xsl:if>
													<xsl:if test="@severity='Major'">
														<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
													</xsl:if>
													<xsl:if test="@severity='Minor'">
														<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
													</xsl:if>
													

													<xsl:if test="@status='PASSED'">
														<td class="tdstyle"> <font color="#008300"> <xsl:value-of select="$status" /> </font> </td>
													</xsl:if>
													<xsl:if test="@status='FAILED'">
														<td class="tdstyle"> <font color="#FF0000"> <xsl:value-of select="$status" /> </font> </td>
													</xsl:if>
													<xsl:if test="@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'">
														<td class="tdstyle"> <font color="#0000FF"> <xsl:value-of select="$status" /> </font> </td>
													</xsl:if>
													
													
													<td class="tdstyle"> <xsl:value-of select="$debuginfo" /> </td>
													<td class="tdstyle"> <xsl:value-of select="$expectedvalue" /> </td>
													<td class="tdstyle"> <xsl:value-of select="$actualvalue" /> </td>
													<td class="tdstyle"> <xsl:value-of select="$loginfo" /> </td>
												</tr>
											</xsl:if>
										</xsl:for-each>
									</table>
								</td>
							</tr>
						</table>
					</div>

					<xsl:for-each select="/validation_report/tcstatus/status">
						<xsl:variable name="tcstatus" select="@name"/>
						<xsl:for-each select="/validation_report/configuredseverities/severity">
							<xsl:variable name="tcseverity" select="@name" />
							

							<div id="{concat($modnames,'_',$tcstatus,'_',$tcseverity)}" style="display:none;">
								<label class='reporth3'><xsl:value-of select="$modnames"/> - <xsl:value-of select="$tcstatus"/> - <xsl:value-of select="$tcseverity" /> </label>
								<br/>
							<table border='0' cellspacing='0' cellpadding='0' class='reporttablebg' width='100%'>
								<tr>
									<td>
										<table border='0' cellspacing='1' cellpadding='5' class='' width='100%'>
											<tr class="thstyle1" align="center">
												<th class="thstyle"> TestCase ID </th>
												<th class="thstyle"> Script Name </th>
												<th class="thstyle"> Severity </th>
												<th class="thstyle"> Status </th>
												<th class="thstyle"> Debug Information </th>
												<th class="thstyle"> Expected Values </th>
												<th class="thstyle"> Actual Values </th>
												<th class="thstyle"> Remarks </th>
											</tr>
												
											<!-- DIV population for each severity and each status for corresponding module -->
											<!--<xsl:variable name="count1" select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/')=$modnames) and @status=$tcstatus and @severity=$tcseverity])" />-->
											<xsl:variable name="count1">
												<xsl:choose>
													<xsl:when test="$modnames='webscripts'">
														<xsl:choose>
															<xsl:when test="$tcstatus='PENDING'">
																<xsl:value-of select="count(/validation_report/report/script/testcases/case[(not(contains(@scriptid,'/'))) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$tcseverity])" />
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="count(/validation_report/report/script/testcases/case[(not(contains(@scriptid,'/'))) and @status=$tcstatus and @severity=$tcseverity])" />
															</xsl:otherwise>
														</xsl:choose>
														
													</xsl:when>

													<xsl:otherwise>
													
														<xsl:choose>
															<xsl:when test="$tcstatus='PENDING'">
																<xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/')=$modnames) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$tcseverity])" />
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/')=$modnames) and @status=$tcstatus and @severity=$tcseverity])" />
															</xsl:otherwise>
														</xsl:choose>
														
													</xsl:otherwise>
												</xsl:choose>
											</xsl:variable>							<!--count1 : to check if there is no testcase available-->
											<xsl:if test="$count1=0">
											<tr class="tdstyle0">
											<td colspan="8" class="reporth2" align="center"> <strong> No TestCase Available </strong> </td>
											</tr>
											</xsl:if>
											<xsl:for-each select="/validation_report/report/script/testcases/case">
												<xsl:variable name="modname">
													<xsl:choose>
														<xsl:when test="contains(@scriptid,'/')">
															<xsl:value-of select="substring-before(@scriptid,'/')" />
														</xsl:when>
														<xsl:otherwise>webscripts</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<xsl:if test="$modname=$modnames">
						
														<xsl:choose>
															<xsl:when test="$tcstatus='PENDING'">      
																<xsl:choose>
																	<xsl:when test="(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$tcseverity">
																		<xsl:variable name="temp" select="position() mod 2" />
																		<xsl:variable name="tcid" select="@id" />
																		<xsl:variable name="scrname">
																			<xsl:choose>
																				<xsl:when test="contains(@scriptid,'/')">
																					<!--<xsl:value-of select="substring-after(@scriptid,'/')" />-->
																					<xsl:call-template name="rindex">
																<xsl:with-param name="string" select="@scriptid"/>
																<xsl:with-param name="substring" select="'/'"/>
															</xsl:call-template>
																				</xsl:when>
																				<xsl:otherwise><xsl:value-of select="@scriptid"/> </xsl:otherwise>
																			</xsl:choose>
																		</xsl:variable>
																		<xsl:variable name="severity" select="@severity" />
																		<xsl:variable name="status" select="@status" />
																		<xsl:variable name="debuginfo" select="@debuginfo" />
																		<xsl:variable name="expvalues" select="@expectedvalue" />
																		<xsl:variable name="actvalues" select="@actualvalue" />
																		<xsl:variable name="loginfo" select="@logmessage" />

																		<tr class="{concat('tdstyle',$temp)}">
																			<td class="tdstyle"> <xsl:value-of select="$tcid" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$scrname" /> </td>
																			<xsl:if test="@severity='ShowStopper'">
																				<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@severity='Critical'">
																				<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@severity='Major'">
																				<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@severity='Minor'">
																				<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>


																			<xsl:if test="@status='PASSED'">
																				<td class="tdstyle"> <font color="#008300"> <xsl:value-of select="$status" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@status='FAILED'">
																				<td class="tdstyle"> <font color="#FF0000"> <xsl:value-of select="$status" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'">
																				<td class="tdstyle"> <font color="#0000FF"> <xsl:value-of select="$status" /> </font> </td>
																			</xsl:if>


																			<td class="tdstyle"> <xsl:value-of select="$debuginfo" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$expvalues" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$actvalues" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$loginfo" /> </td>
																		</tr>
																	
																	
																	</xsl:when>
																	<xsl:otherwise/>
																</xsl:choose>
															</xsl:when>

															<xsl:otherwise> <!-- testing for passed or failed testcases -->
																<xsl:choose>
																	<xsl:when test="@status=$tcstatus and @severity=$tcseverity">
																		<xsl:variable name="temp" select="position() mod 2" />
																		<xsl:variable name="tcid" select="@id" />
																		<xsl:variable name="scrname">
																			<xsl:choose>
																				<xsl:when test="contains(@scriptid,'/')">
																					<!--<xsl:value-of select="substring-after(@scriptid,'/')" />-->
																					<xsl:call-template name="rindex">
																<xsl:with-param name="string" select="@scriptid"/>
																<xsl:with-param name="substring" select="'/'"/>
															</xsl:call-template>
																				</xsl:when>
																				<xsl:otherwise><xsl:value-of select="@scriptid"/> </xsl:otherwise>
																			</xsl:choose>
																		</xsl:variable>
																		<xsl:variable name="severity" select="@severity" />
																		<xsl:variable name="status" select="@status" />
																		<xsl:variable name="debuginfo" select="@debuginfo" />
																		<xsl:variable name="expvalues" select="@expectedvalue" />
																		<xsl:variable name="actvalues" select="@actualvalue" />
																		<xsl:variable name="loginfo" select="@logmessage" />

																		<tr class="{concat('tdstyle',$temp)}">
																			<td class="tdstyle"> <xsl:value-of select="$tcid" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$scrname" /> </td>
																			<xsl:if test="@severity='ShowStopper'">
																				<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@severity='Critical'">
																				<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@severity='Major'">
																				<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@severity='Minor'">
																				<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
																			</xsl:if>


																			<xsl:if test="@status='PASSED'">
																				<td class="tdstyle"> <font color="#008300"> <xsl:value-of select="$status" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@status='FAILED'">
																				<td class="tdstyle"> <font color="#FF0000"> <xsl:value-of select="$status" /> </font> </td>
																			</xsl:if>
																			<xsl:if test="@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'">
																				<td class="tdstyle"> <font color="#0000FF"> <xsl:value-of select="$status" /> </font> </td>
																			</xsl:if>


																			<td class="tdstyle"> <xsl:value-of select="$debuginfo" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$expvalues" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$actvalues" /> </td>
																			<td class="tdstyle"> <xsl:value-of select="$loginfo" /> </td>
																		</tr>
																	
																	
																	</xsl:when>
																	<xsl:otherwise/>
																</xsl:choose>
															</xsl:otherwise>
														</xsl:choose>

													</xsl:if>

												<!-- done successfully -->	
											</xsl:for-each>


										</table>
									</td>
								</tr>
							</table>
						</div>
					</xsl:for-each>
				</xsl:for-each>
					</body>
				</html>
			</xalan:write>
		</xsl:for-each>


		<xalan:write select="concat($repdir,'/','top.html')">
			<html>
				<head>
				<link href="{concat('/','framework','/','styles','/',$currentTheme,'/','qengine.css')}" rel="stylesheet" type="text/css"/>
				<title>QEngine Web Test Studio : Script Report</title> 
				</head>
				<body bgcolor="#FFFFFF" text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
					<table width="100%" border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td background="/qehome/images/bg_top.gif" height="69" valign="bottom">
								<div align="center">
									<table width="45%" border="0" cellspacing="0" cellpadding="0" align="left">
									<tr>
										<td><i><font color="#FFFFFF"></font></i></td>
										<td><i><font color="#FFFFFF"><b>QEngine - Web Client Test Report</b></font></i></td>
									</tr>
									<tr>
										<td><br></br></td>
										<td></td>
									</tr>
									</table>
								</div>
								</td> 
						</tr>
					</table>
				</body>
			</html>
		</xalan:write>
		<xalan:write select="concat($repdir,'/','left.html')">
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
						<![CDATA[
	<style type="text/css">
		body { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; }
a:link{ color: #000000; text-decoration: none;}
a:visited{ color: #000000; text-decoration: none;}
a:active{ color: #000000; text-decoration: none; }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.lefttreeheader { font-family: Verdana, Arial, Helvetica, sans-serif; padding:5px; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border:#b0b0b1 1px solid; color:#000000; font-size:11px; text-decoration:none; font-style:normal; font-weight:bold;}
.lefttreeheadermod { font-family: Verdana, Arial, Helvetica, sans-serif; padding:5px; background-color:#ece9d8; background-image:url(/qehome/images/headerbg.gif); border:#b0b0b1 1px solid; color:rgb(73,47,151); font-size:11px; text-decoration:none; font-style:normal; font-weight:bolder; }
.lefttreeheader1 { font-family: Verdana, Arial, Helvetica, sans-serif; padding:5px; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); color:#000000; font-size:9px; text-decoration:none; font-style:normal; font-weight:normal;}
.lefttreeheader2 { font-family: Verdana, Arial, Helvetica, sans-serif; padding:5px; background-color:#ece9d8; background-image:url(/qehome/images/headerbg.gif); border:0px; color:#000000; font-size:11px; text-decoration:none; font-style:normal; font-weight:bold;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:12px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:12px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.reporttablebg1 { border: 1px #b0b0b1 solid; background-image:url(/qehome/images/TabBg.gif); background-repeat:repeat-x; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlink a{  font: 11px Verdana, Arial, Helvetica, sans-serif; color: #000000; text-decoration:underline}
.tdlink a:hover { background-color:#e1ecff; text-decoration:none}
.tdlink a:active { color:#000000; font-weight:bold;}
.tdlink a:visited { color:#000000; text-decoration:underline;}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
.style1 {color: #F7F7F7}
.nonselectedtab {
font-family:Verdana, Arial, Helvetica, sans-serif;
font-size:12px;
color:#000000;
background-image:url(/framework/images/TabBg.gif);
cursor:pointer;
border-left: 1px solid #a6c1e9;
}
                   </style>

				   <script language="JavaScript">
						var firstanchor;
					   
					function idGet(id) 
					{
						if (typeof(document.getElementsByName) != "undefined") 
						{
							var imgColl = document.getElementsByName("scriptimage");
							for (i = 0; i < imgColl.length; i++)
							{
								var x = imgColl[i];
								if(!x)
									continue;
									x.src = "/qehome/images/ball.gif";
							}
						}
						if (typeof(document.getElementById) != "undefined") 	
						{
							return document.getElementById(id);
						} else {
							return document.all[id];
						}
						
					}

function MM_openBrWindow(theURL,winName,features) { //v2.0
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}
		var d = new Date();
	   var dateStr = d.toGMTString();

  window.open(theURL+".html?datestring="+dateStr,winName,features);
}


	function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}
function showFirstDiv()
{
	var heading = document.getElementsByTagName("div");
	heading[0].style.display="block";

}

function showHideHeadDiv(id)
{
	try
	{
		headdivlist = document.getElementsByTagName("DIV");
		for(var i=0;i<headdivlist.length;i++)
		{
			divlistid = headdivlist[i].id;
			divstring = divlistid.substring(divlistid.length=7,divlistid.length);
			if(divstring=="_moddiv")
			{
				headdivlist[i].style.display=none;
				if(headdivlist[i].id==id)
				{
					headdivlist[i].style.display="block";
				}
			}
		}
		
	}
	catch(e) {}
}

function showDiv(id,elem)
{
	hideAllScriptLevelDiv();
	try
	{
			var heading = document.getElementsByTagName("div");
				
			for(i=0;i<heading.length;i++)
			{
				divid = heading[i].id;
				
				if(divid.indexOf(elem)!=-1)
				{
				//heading[i].style.display = "block";
				expandScriptDiv(divid);
					break;
				}				
			}
	}
	catch(e) {}
}


function hideAllScriptLevelDiv()
{
	try
	{
		var hd = document.getElementsByTagName("DIV");
		for(var i=0;i<hd.length;i++)
		{
			hdid = hd[i].id;
			hdidsubstr = hdid.substring(hdid.length-9,hdid.length);
			if(hdidsubstr=="_scrlevel")
			{
				hd[i].style.display="none";
			}
		}
	}
	catch(e)
	{}
}


function showScriptForMod(elem)
{
	itext = elem.innerHTML;
	imgid = "img__"+itext;
	divlist = document.getElementsByTagName("DIV");
	tofind = "_mod__"+itext;
	for(var j=0;j<divlist.length;j++)
	{
		divtofind = divlist[j].id;
		if(divtofind.indexOf(tofind)!=-1)
		{
			divlist[j].style.display="block";
		}
		else
		{
			divlist[j].style.display="none";
		}
	}
	document.getElementById(imgid).src="/framework/images/right.gif";
	
	}


	function showScriptFromTR(elem)
	{
		//here the elem refers to the id of the element
		try
		{
			divtohide = document.getElementById("summaryreport_desc");
			eval("divtohide.style.display='none';");
			idsubstr = elem ;
			idtosend = idsubstr.substring(3,idsubstr.length);
			changeOtherImgIndication(idtosend);
			elemid = elem ;		//id of the table row
			elemid = elemid.substring(3,elemid.length);
			imgid = "img__"+elemid;				//getting the image id
			elemhtml = document.getElementById(imgid).src;
			if(elemhtml.indexOf("tree-down.gif")!=-1)
			{
				document.getElementById(imgid).src = "/framework/images/tree-up.gif";
				divlist = document.getElementsByTagName("DIV");
				for(var j=0;j<divlist.length;j++)
				{	
					dividtoexpand = divlist[j].id;
					if(dividtoexpand.indexOf("_mod__")!=-1)
					{
						divsubstr = dividtoexpand.substring(dividtoexpand.indexOf("_mod__")+6,dividtoexpand.length);
						if(divsubstr==elemid)
						{

							divlist[j].style.display="block";
						}
						else
						{
							divlist[j].style.display="none";
						}
					}	
				}
				expandfromtr(elem);	
			}
			else if(elemhtml.indexOf("tree-up.gif")!=-1)
			{
				document.getElementById(imgid).src = "/framework/images/tree-down.gif";
				divlist = document.getElementsByTagName("DIV");
				for(var i=0;i<divlist.length;i++)
				{
					divlist[i].style.display="none";
				}
				
			}
		}
		catch(e)
		{
		}
	}



function hideOtherDiv()
{
	divlist = document.getElementsByTagName("DIV");
	for(var j=0;j<divlist.length;j++)
	{
		eval("divlist[j].style.display='none';");
	}
	divtoshow = document.getElementById("summaryreport_desc");
	eval("divtoshow.style.display='block';");
}


function changeiconnotifier()
{
	try
	{
		imglist = document.getElementsByTagName("IMG");
		for(var j=0;j<imglist.length;j++)
		{
			imglistid = imglist[j].id;
			if(imglistid!=null && imglistid.indexOf("img__")!=-1)
			{
				imglist[j].src = "/framework/images/tree-down.gif";
			}
		}
		
	}
	catch(e)
	{}
}
	function expandFirstDiv(elem)
	{
		var myArr = new Array();
		if(elem=="undefined")
		{
			itext = elem.innerHTML.replace(/<[^>]>/g,"")
		}
		divlist = document.getElementsByTagName("DIV");
		tofind = "_mod__"+itext;
		var i = 0;
		for(var j=0;j<divlist.length;j++)
		{
			divtofind = divlist[j].id ;
			if(divtofind.indexOf(tofind)!=-1)
			{
				myArr[i] = divtofind;
				i++;

			}
		}
		divtoexpand = document.getElementById(myArr[0]);
		trArray = divtoexpand.getElementsByTagName("TR");
		trid = trArray[0].id;
		document.getElementById(trid).click();
		innerDivElem = divtoexpand.getElementsByTagName("DIV");
		innerDivElem[0].style.display = "block";
	}
	function clearStyles()
	{
		firstanchor.style.fontWeight="";
	}
	function expandfromtr(elem)
	{
		var myArr = new Array();
		elemid = elem ;
		elemid = elemid.substring(3,elemid.length);
		divlist = document.getElementsByTagName("DIV");
		tofind = "_mod__"+elemid;
		var i=0;
		for(var j=0;j<divlist.length;j++)
		{
			divtofind = divlist[j].id;
			if(divtofind.indexOf(tofind)!=-1)
			{
				myArr[i] = divtofind ;
				i++ ;
			}
		}
		divtoexp = document.getElementById(myArr[0]);
		divtoexp.style.display = 'block';
		script = myArr[0].substring(2,myArr[0].indexOf("_mod"));
		var scriptname = script;
		if(script.indexOf("/") != -1)
		{
			scriptname = script.substring(script.lastIndexOf("/")+1,script.length);
		}
		scrlevelid = "./"+script +"/"+scriptname+"_scrlevel";
		expandScriptDiv(scrlevelid);

	}

	function expandScriptDiv(scriptdivid)
	{
		divtoexp = document.getElementById(scriptdivid);
		divtoexp.style.display = "block";

		firstanchor = getAnchorNodeFor(divtoexp);
		firstanchor.focus();

		firstanchor.style.fontWeight = 'bold';
	}

	function getAnchorNodeFor(elem)
	{
		var childs = elem.childNodes;
		if(childs.length > 0)
		{
			for(i=0;i<childs.length;i++)
			{
				var tagName = childs[i].nodeName;
				if(tagName == 'TD')
				{
					var anchorArr = childs[i].getElementsByTagName('A');
					return anchorArr[0];
				}
				else if(tagName != '#text')
				{
					return getAnchorNodeFor(childs[i]);
				}
			}
		}
	}
			
	

	function changeOtherImgIndication(elem)
	{
		imgtoskip = "img__"+elem;
		try
		{
			imgList = document.getElementsByTagName("IMG");
			for(var j=0;j<imgList.length;j++)
			{
				imageID = imgList[j].id;
				if(imageID!=null && imageID.indexOf("img__")!=-1)
				{
					if(imageID!=imgtoskip)
					{
						imgList[j].src = "/framework/images/tree-down.gif";
					}
				}
			}
		}
		catch(e) {}
	}

</script>
					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Script Report</title>
				</head>
				<body bgcolor="#f7f7f7"  onload="checkForPrint();" text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
					<br></br>
					<table width="100%" border="0" cellspacing="0" cellpadding="3">
						<tr>
							<td colspan="2" height="37">
								<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
									<tr id="summarytr" onclick="javascript:parent.showPage('scriptsummary.html');hideOtherDiv();changeiconnotifier();">
										<td class="lefttreeheadermod"  onclick="javascript:parent.showPage('scriptsummary.html');" style="cursor:hand;border:0px;">Summary Report</td>
									</tr>
									<tr>
										<td id="summaryreport_desc" style="display:block;padding-left:10px; padding-bottom:5px;padding-top:5px;" class="tdlink" bgcolor="#FFFFFF"><a href="javascript:parent.showPage('scriptsummary.html');" onclick="hideOtherDiv();" target="main"><b>Summary</b></a></td>
									</tr>
								</table>
							</td>
						</tr>
						
						<tr>
	  					<td colspan="2" valign="top">
						<xsl:for-each select="/validation_report/moduleslist/module">
							<xsl:variable name="modname" select="@name"/>
							<table width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
								<tr id="{concat('tr_',$modname)}" onclick="showScriptFromTR(this.id);javascript:parent.showModPage('{concat($modname,'.html')}','{concat($modname,'_div')}');">
									<td class="lefttreeheadermod" height="21" style="padding-left:5px; font-weight:bold; border:0px; cursor:hand;"><xsl:value-of select="$modname"/></td><td class="lefttreeheader2" style="border-left:0px;cursor:hand;" align="right"><a href="#"><img id="{concat('img__',$modname)}" width="12" height="12" src='/framework/images/tree-down.gif' style="border:0px;" /></a></td>
								</tr>
								<tr>
									<td colspan="2">
						
										<xsl:for-each select="$scriptDetails">
											<xsl:variable name="keyvalwithmod" select="@namewithmod"/>
											<xsl:variable name="keyval" select="@name"/>
											<xsl:if test="$modname='webscripts'">
												<xsl:if test="not(contains($keyvalwithmod,'/'))">
													<div id="{concat('./',$keyvalwithmod,'_mod__',$modname)}" style="display:none;">
											<table width="100%"  border="0" cellpadding="0" cellspacing="0" class="reporttablebg" style="padding-top:0px; padding-bottom:0px;">
												<tr id="{concat($modname,'-',$keyval)}" onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');showDiv('{concat('./',$keyvalwithmod,'/',$keyval)}','{concat($keyval,'_scrlevel')}');" style="cursor:pointer">
													<td colspan="2" class="lefttreeheader" style="padding-left:10px; border:0px; border-bottom:1px solid;"><a title="{concat('./',$keyvalwithmod,'/',$keyval)}" ><xsl:value-of select="$keyval"/></a></td>
												</tr>
												<tr>
													<td colspan="2">
														<div id="{concat('./',$keyvalwithmod,'/',$keyval,'_scrlevel')}" style="display:none">
														<table width="100%"  border="0" cellspacing="0" cellpadding="4">
															<tr class="reporttablebg" onclick="parent.showTCPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');">
																<td bgcolor="#FFFFFF" class="tdlink" style="padding-left:10px;"><a target="main" href="javascript:parent.showTCPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"> Testcase Report </a></td>
															</tr>
															<tr class="reporttablebg" onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html')}');">
																<td bgcolor="#FFFFFF" class="tdlink" style="padding-left:10px;"><a target="main" href="javascript:parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html')}');">Script Report</a></td>
															</tr>
															<tr class="reporttablebg"  onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_pageprop.html')}');">
																<td bgcolor="#FFFFFF" class="tdlink" style="padding-left:10px;"><a target="main" href="javascript:parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_pageprop.html')}');">Page Property Report </a></td>
															</tr>
															<tr class="reporttablebg">
																<td bgcolor="#FFFFFF" class="bodytext tdlink" style="padding-left:10px; font:11px Verdana, Arial, Helvetica, sans-serif; color:#000000;">  Logs : 
																<xsl:choose>
																	<xsl:when test="$outfile='multiple'">
																		<a href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=out')}" target="main">Outfile</a> 
																	</xsl:when>
																	<xsl:otherwise>
																		<a href="{concat($pathToLogsDirFromSum,'/',$keyvalwithmod,'/testout0.txt')}" target="main">Outfile</a> 
																	</xsl:otherwise>
																</xsl:choose>| 
																<xsl:choose>
																	<xsl:when test="$errfile='multiple'">
																		<a  href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=err')}" target="main">ErrFile</a>
																	</xsl:when>
																	<xsl:otherwise>
																		<xsl:choose>
																			<xsl:when test="$errfile='empty'">
																				<a href="/framework/html/noerror.html" target="main">ErrFile</a>
																			</xsl:when>
																			<xsl:otherwise>
																			<a  class="tdlink" href="{concat($pathToLogsDirFromSum,'/',$keyvalwithmod,'/testerr0.txt')}" target="main">ErrFile</a> 
																			</xsl:otherwise>
																		</xsl:choose>
																	</xsl:otherwise>
																</xsl:choose>
																</td>
															</tr>
														</table>
														</div>
													</td>
												</tr>
											</table>
										</div>
									</xsl:if>
								</xsl:if>
								<!--For webscripts-->
								<xsl:if test="not($modname='webscripts')">
												<xsl:if test="contains($keyvalwithmod,$modname)">
													<div id="{concat('./',$keyvalwithmod,'_mod__',$modname)}" style="display:none;">
											<table width="100%"  border="0" cellpadding="0" cellspacing="0" class="reporttablebg" style="padding-top:0px; padding-bottom:0px;">
												<tr id="{concat($modname,'-',$keyval)}" onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');showDiv('{concat('./',$keyvalwithmod,'/',$keyval)}','{concat($keyval,'_scrlevel')}');" style="cursor:pointer">
													<td colspan="2" class="lefttreeheader" style="padding-left:10px; border:0px; border-bottom:1px solid;"> <a title="{concat('./',$keyvalwithmod,'/',$keyval)}" ><xsl:value-of select="$keyval"/></a></td>
												</tr>
												<tr>
													<td colspan="2">
														<div id="{concat('./',$keyvalwithmod,'/',$keyval,'_scrlevel')}" style="display:none">
														<table width="100%"  border="0" cellspacing="0" cellpadding="4">
															<tr class="reporttablebg" onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');">
																<td bgcolor="#FFFFFF" class="tdlink" style="padding-left:10px;"><a target="main" href="javascript:parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"> Testcase Report </a></td>
															</tr>
															<tr class="reporttablebg" onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html')}');">
																<td bgcolor="#FFFFFF" class="tdlink" style="padding-left:10px;"><a target="main" href="javascript:parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html')}');">Script Report</a></td>
															</tr>
															<tr class="reporttablebg"  onclick="parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_pageprop.html')}');">
																<td bgcolor="#FFFFFF" class="tdlink" style="padding-left:10px;"><a target="main" href="javascript:parent.showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_pageprop.html')}');">Page Property Report </a></td>
															</tr>
															<tr class="reporttablebg">
																<td bgcolor="#FFFFFF" class="bodytext tdlink" style="padding-left:10px; font:11px Verdana, Arial, Helvetica, sans-serif; color:#000000;">  Logs : 
																<xsl:choose>
																	<xsl:when test="$outfile='multiple'">
																		<a href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=out')}" target="main">Outfile</a> 
																	</xsl:when>
																	<xsl:otherwise>
																		<a class="tdlink" href="{concat($pathToLogsDirFromSum,'/',$keyvalwithmod,'/testout0.txt')}" target="main">Outfile</a> 
																	</xsl:otherwise>
																</xsl:choose>| 
																<xsl:choose>
																	<xsl:when test="$errfile='multiple'">
																		<a  href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=err')}" target="main">ErrFile</a>
																	</xsl:when>
																	<xsl:otherwise>
																		<xsl:choose>
																			<xsl:when test="$errfile='empty'">
																				<a href="/framework/html/noerror.html" target="main">ErrFile</a>
																			</xsl:when>
																			<xsl:otherwise>
																			<a  href="{concat($pathToLogsDirFromSum,'/',$keyvalwithmod,'/testerr0.txt')}" target="main">ErrFile</a> 
																			</xsl:otherwise>
																		</xsl:choose>
																	</xsl:otherwise>
																</xsl:choose>
																</td>
															</tr>
														</table>
														</div>
													</td>
												</tr>
											</table>
										</div>
									</xsl:if>
								</xsl:if>



						</xsl:for-each>
					</td>
				</tr>
					</table>
					</xsl:for-each>
						</td>
					  </tr>

					</table>
				</body>
			</html>
		</xalan:write>
		<xsl:for-each select="$scriptDetails">
			<xsl:variable name="scriptnode" select="."/>
			<xsl:variable name="scriptcasenode" select="$scriptnode/scriptcases/case"/>
			<xsl:variable name="keyvalwithmod" select="@namewithmod"/>
			<xsl:variable name="modadjusturlval" select="@modadjusturl"/>
			<xsl:variable name="keyval" select="@name"/>
			<xsl:variable name="executiontime" select="@executiontime"/>
			<xsl:value-of select="$keyval"/>
			<xsl:variable name="modnamefromscript">
				<xsl:choose>
					<xsl:when test="contains(@namewithmod,'/')">
						<xsl:value-of select="substring-before(@namewithmod,'/')" />
					</xsl:when>
					<xsl:otherwise>webscripts</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			
			<xalan:write select="concat($repdir,'/',$keyvalwithmod,'/',$keyval,'.html')">
				<html>
					<head>
						<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
body { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a:link{ color: #000000; text-decoration: underline;}
a:visited{ color: #000000; text-decoration: underline;}
a:active{ color: #000000; text-decoration: underline; }
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-weight:bold; font-style:normal;}
.thstyle11 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.style4 {color: #FF0000}
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000CC0}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="JavaScript">
function showFailureReportDiv()
{
	document.getElementById("failurereportdiv").style.display="block";
	document.getElementById("compeletereportdiv").style.display="none";
}

function showCompleteReportDiv()
{
	document.getElementById("failurereportdiv").style.display="none";
	document.getElementById("compeletereportdiv").style.display="block";
}
function showPage(url)
{
	var d = new Date();
	dateStr = d.toGMTString();
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;
}
function MM_openBrWindow(theURL,winName,features) 
{ //v2.0
	while(winName.indexOf(" ")>0)
	{
		winName = winName.replace(" ","_");
	}

	var d = new Date();
	dateStr = d.toGMTString();
	window.open(theURL+".html?datestring"+dateStr,winName,features);
}


function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}
function checkForFailureReport()
{
	url = document.URL;
	if(url.indexOf("#failuresLink")>-1)
	{
		showFailureReportDiv();
	}
	else
	{
		showCompleteReportDiv();
	}

}
function showModPage(url,divid)
{
window.parent.document.getElementById("main").src=url+"?divtoopen="+divid;
}

function alertFrameslist()
{
 	frameslist = window.parent.document.getElementsByTagName("frames");
	for(i=0;i<frameslist.length;i++)
	{
		alert(frameslist[i].name);
	}
}
function showsummaryreport()
{
	alertFrameslist();
	trarrlist = window.parent.document.getElementById("main").getElementsByTagName("TR");
	alert(trarrlist);
	for(j=0;j<trarrlist.length;j++)
	{
		trarrid=trarrlist[j].id;
		if(traarrid==null || trarrid=="")
		{
			break;
		}
		else
		{
			alert(trarrid);
		}
	}
}
function invokeSummaryLeftReport()
{
	window.parent.frames[0].hideOtherDiv();
	window.parent.frames[0].changeiconnotifier();
}
function showModuleLeftReport(url)
{
	url = url.substring(0,url.indexOf("::skip"));
	window.parent.frames[0].showScriptFromTR(url);
}
function showTCReport(modname,scriptname)
{
	if(modname=='webscripts')
	{
		modname="";
	}
	modname = modname+"/" ;
	paramurl = "."+modname+scriptname+"/"+scriptname+"_tcReport.html";
	parent.showPage(paramurl);
}
	</script>


						]]>
						</xsl:text>
					<title>QEngine Web Test Studio : Script Report</title>
					</head>

					<script>
						var d = new Date();
						dateStr = d.toGMTString();
					</script>
					<body bgcolor="#FFFFFF" text="#000000" onload="checkForPrint();checkForFailureReport();">

						
						<table width="99%" border="0" cellspacing="0" cellpadding="0" align="center">
						<tr>
							<td height="30" colspan="2" class="bodytext"><a href="javascript:showPage('scriptsummary.html');" onclick="javascript:invokeSummaryLeftReport();">Summary Report</a> &gt; <a href="javascript:showPage('scriptsummary.html');" onclick="javascript:invokeSummaryLeftReport();"><xsl:value-of select="/validation_report/testconfigdetails/@suitename" /></a> &gt; <a href="javascript:showModPage('{concat($modnamefromscript,'.html')}','{concat($modnamefromscript,'_div')}')" onclick="javascript:showModuleLeftReport('{concat($modnamefromscript,'::skip')}');"> <xsl:value-of select="$modnamefromscript"/> </a> &gt; <a href="#" onclick="javascript:showTCReport('{$modnamefromscript}','{$keyval}');"> <xsl:value-of select="$keyval"/></a> &gt; Script Report </td>
 						</tr>
						<tr bgcolor="#ffffff">
							<td width="68%" height="20" class="reporth3">Script Report : <xsl:value-of select="$keyval"/> <span class="bodytext">  (Execution Duration: <xsl:value-of select="@executiontime"/> secs)</span></td>
							<td id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('{$keyval}', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
						</tr>
						<tr>
							<td height="1" colspan="3"><span class="reporthline"><img height="1" width="1" src="/framework/images/spacer.gif"></img></span></td>
							</tr>
							<tr>
								<td height="30" colspan="2" class="reporth2">This report shows the Failure and Complete Report for a script with details such as Action which caused the failure, Status such as Passed or Failed, Debug Information , Remarks and status of each line executed in the script .</td>
							</tr>
						</table>
							<table width="50%"  border="0" align="center" cellpadding="4" cellspacing="0" class="reporttablebg">
								<tr>
									<td width="22%" class="thstyle2">Status</td>
									<td width="46%" class="thstyle2">Debug Information</td>
									<td width="15%" class="thstyle2">Passed</td>
									<td width="17%" class="thstyle2">Failure</td>
								</tr>
							<xsl:variable name="idName" select="@namewithmod"/>
							<xsl:variable name="status" select="@status"/>
							<xsl:variable name="debugInfo" select="@debuginfo"/>
							<tr class="tdstyle">

								<td class="tdstyle">
									<xsl:if test="$status='COMPLETED'">
										<font color="#669966"><xsl:value-of select="$status"/></font>
									</xsl:if>
									<xsl:if test="$status='INCOMPLETE'">
										<font color="#0000CC"><xsl:value-of select="$status"/></font>
									</xsl:if>												
								</td>
								<td class="tdstyle"><xsl:value-of select="$debugInfo"/>
								</td>
								<td class="tdstyle" width="22%"><xsl:value-of select="count($scriptcasenode[@status='PASSED' or @status='COMPLETED'])"/>
								</td>
								<td class="tdstyle"><a href="javascript:showFailureReportDiv();"><xsl:value-of select="count($scriptcasenode[@status!='COMPLETED' and @status!='PASSED'])"/></a>
								</td>
							</tr>
						</table>
						<br></br>						
						<div id="failurereportdiv" style="display:none" width="90%">
						<xsl:choose>
						<xsl:when test="count($scriptcasenode[@status!='COMPLETED' and @status!='PASSED'])>0">
						<table width="99%" border="0" align="center" cellpadding="4" cellspacing="0" class="reporttablebg">
						   <tr bgcolor="#ffffff">
							<td colspan="4" class="thstyle">
							<table width="100%" height="24" cellpadding="0" cellspacing="0"> <tr class="thstyle">		<td>Failure Report </td>
							<td align="right"><a href="javascript:showCompleteReportDiv();"><strong>Complete Report</strong></a>
							</td>
							</tr>
							</table>
	   						</td>
  						 </tr>
						 <tr>
							 <td width="58%"  class="thstyle11">Action </td>
							 <td width="8%"  class="thstyle11">Status</td>
							 <td width="17%"  class="thstyle11">Debug Information </td>
							 <td width="17%"  class="thstyle11">Remarks</td>
						 </tr>

											<xsl:for-each select="$scriptnode/scriptcases/case">
											<xsl:sort order="ascending" select="@time" data-type="number"/>
												<xsl:variable name="casenode" select="."/>
												<xsl:variable name="screenshottrue" select="true"/>
												<xsl:variable name="idFromScript" select="@id"/>
												<xsl:variable name="severity" select="@severity"/>
												<xsl:variable name="status" select="@status"/>
												<xsl:variable name="debugInfo" select="@debuginfo"/>
												<xsl:variable name="remarks" select="@logmessage"/>
												<xsl:variable name="isscreenshot" select="@screenshot"/>
												<xsl:variable name="scriptid" select="@scriptid"/>
												<xsl:choose>
												<xsl:when test="$status='PASSED'">
												</xsl:when>	
								    			<xsl:otherwise>
												<xsl:choose>
													<xsl:when test="$status='COMPLETED'">
													</xsl:when>
													<xsl:otherwise>
														<xsl:variable name="temp" select="position() mod 2"/>
														<tr class="{concat('tdstyle',$temp)}">
															<td class="tdstyle"><xsl:value-of select="$idFromScript"/></td>
															<td class="tdstyle" >
																<xsl:if test="$status='FAILED'">
																	<font color="#FF0000"><xsl:value-of select="$status"/></font>
																</xsl:if>
																<xsl:if test="$status='PASSED'">
																	<font color="#009900"><xsl:value-of select="$status"/></font>
																</xsl:if>
																<xsl:if test="$status='DATA_ERROR'">
																	<font color="#AF0000"><xsl:value-of select="$status"/></font>
																</xsl:if>
																<xsl:if test="$status='ENVIRONMENT_ERROR'">
																	<font color="#AF0000"><xsl:value-of select="$status"/></font>
																</xsl:if>
																<xsl:if test="$status='INCOMPLETE'">
																	<font color="#0000CC"><xsl:value-of select="$status"/></font>
																</xsl:if>
															</td>
															<td class="tdstyle" ><xsl:value-of select="$debugInfo"/> </td>
															<xsl:choose>
																<xsl:when test="$isscreenshot>0">
																   <xsl:variable name="screenshotname" select="@screenshotname"/>
																    <td  class="tdstyle" >
																	    <a href="{concat('screenshots/',$screenshotname)}" target="_new"> <xsl:value-of select="$remarks"/></a>
																    </td>
															    </xsl:when>	
															    <xsl:otherwise>
																	<td  class="tdstyle" >
																		<xsl:value-of select="$remarks"/> 
																		<xsl:if test="$keyval!=@scriptid">
																		  <xsl:text>&#x0a;</xsl:text>- Script : <xsl:value-of select="$scriptid"/>
																		</xsl:if>	
																	</td>
															    </xsl:otherwise>
															</xsl:choose>
														</tr>
													</xsl:otherwise>
												</xsl:choose>
												</xsl:otherwise>
												</xsl:choose>
											</xsl:for-each>
							</table>
						</xsl:when>
						<xsl:otherwise>
							<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0" class="reporttablebg">
								<tr bgcolor="#ffffff">
							<td >
							<table width="100%" height="24" cellpadding="0" cellspacing="0"> <tr class="thstyle">		<td>Failure Report </td>
							<td align="right"><a href="javascript:showCompleteReportDiv();"><strong>Complete Report</strong></a>
							</td>
							</tr>
							</table>
	   						</td>
  						 </tr>
								<tr>
									<td height="24" align="center" class="bodytext">
										<xsl:variable name="scrstatus" select="$scriptnode/@status"/>
										<xsl:variable name="scrdebugInfo" select="$scriptnode/@debuginfo"/>
										<xsl:if test="$scrstatus='INCOMPLETE'">
											<xsl:value-of select="$scrdebugInfo"/>
										</xsl:if>
										<xsl:if test="$scrstatus='COMPLETED'">
											No Script Failures
										</xsl:if>
										<strong>
									</strong></td>
								</tr>
							</table>
						</xsl:otherwise>
					</xsl:choose>
				</div>
				<div id="compeletereportdiv" style="display:none;">
						<h2><a name="completeStatusLink"></a></h2>
						<xsl:choose>
						<xsl:when test="count($scriptcasenode)>0">
							<table width="99%"  border="0" align="center" cellpadding="4" cellspacing="0" class="reporttablebg">
								<tr class="thstyle2">
									<td colspan="3" >Complete  Report</td>
									<td align="right" ><a href="javascript:showFailureReportDiv();"><strong>Failure Report </strong></a>
									</td>
								</tr>
								<tr>
									<td width="58%"  class="thstyle11">Action </td>
									<td width="8%"  class="thstyle11">Status</td>
									<td width="17%"  class="thstyle11">Debug Information </td>
									<td width="17%"  class="thstyle11">Remarks</td>
								</tr>
								
								<xsl:for-each select="$scriptnode/scriptcases/case">
									<xsl:sort order="ascending" select="@time" data-type="number"/>
									<xsl:variable name="casenode" select="."/>
									<xsl:variable name="screenshottrue" select="true"/>
									<xsl:variable name="idFromScript" select="@id"/>
									<xsl:variable name="severity" select="@severity"/>
									<xsl:variable name="status" select="@status"/>
									<xsl:variable name="debugInfo" select="@debuginfo"/>
									<xsl:variable name="remarks" select="@logmessage"/>
									<xsl:variable name="isscreenshot" select="@screenshot"/>
									<xsl:variable name="scriptid" select="@scriptid"/>
									<xsl:variable name="temp" select="position() mod 2"/>
									<tr class="{concat('tdstyle',$temp)}">
										<td class="tdstyle"><xsl:value-of select="$idFromScript"/></td>
										<td class="tdstyle">
											<xsl:if test="$status='FAILED'">
												<font color="#FF0000"><xsl:value-of select="$status"/></font>
											</xsl:if>
											<xsl:if test="$status='PASSED'">
												<font color="#009900"><xsl:value-of select="$status"/></font>
											</xsl:if>
											<xsl:if test="$status='DATA_ERROR'">
												<font color="#AF0000"><xsl:value-of select="$status"/></font>
											</xsl:if>
											<xsl:if test="$status='ENVIRONMENT_ERROR'">
												<font color="#AF0000"><xsl:value-of select="$status"/></font>
											</xsl:if>
											<xsl:if test="$status='INCOMPLETE'">
												<font color="#0000CC"><xsl:value-of select="$status"/></font>
											</xsl:if>
										</td>
										<td class="tdstyle"><xsl:value-of select="$debugInfo"/> </td>
										<xsl:choose>
											<xsl:when test="$isscreenshot>0">
												<xsl:variable name="screenshotname" select="@screenshotname"/>
												<td class="tdstyle">
													<a href="{concat('screenshots/',$screenshotname)}" target="_new"> <xsl:value-of select="$remarks"/></a>
												</td>
											</xsl:when>	
											<xsl:otherwise>
												<td class="tdstyle">
													<xsl:value-of select="$remarks"/> 
													<xsl:if test="$keyval!=@scriptid">
														<xsl:text>&#x0a;</xsl:text>- Script : <xsl:value-of select="$scriptid"/>
													</xsl:if>	
												</td>
											</xsl:otherwise>
										</xsl:choose>
									</tr>
								</xsl:for-each>
							</table>
						</xsl:when>
						<xsl:otherwise>
							<table width="500" height="200" align="center" border="0" cellpadding="0" cellspacing="0" bordercolor="#333333" class="reporttablebg">
  <tr>
									<td align="center" class="thstyle1"> 

									<xsl:variable name="scrstatus" select="$scriptnode/@status"/>
									<xsl:variable name="scrdebugInfo" select="$scriptnode/@debuginfo"/>
									<!--<xsl:if test="$scrstatus='INCOMPLETE'">
										    <xsl:value-of select="$scrdebugInfo"/>
									    </xsl:if>-->
										<xsl:if test="$scrstatus='COMPLETED'">
<h1>No Script Failures</h1>
									</xsl:if>
						   		</td>
							   </tr>
							</table>
						</xsl:otherwise>
						</xsl:choose>
						</div>

					</body>
				</html>
			</xalan:write>
		</xsl:for-each>
		<xsl:for-each select="$scriptDetails">
			<xsl:variable name="scriptnode1" select="."/>
			<xsl:variable name="casereport" select="$scriptnode1/testcases/case"/>
			<xsl:variable name="keyvalwithmod" select="@namewithmod"/> 
			<xsl:variable name="modadjusturlval" select="@modadjusturl"/>
			<xsl:variable name="keyval" select="@name"/> 
			<xsl:variable name="modnamefortcreport">
				<xsl:choose>
					<xsl:when test="contains(@namewithmod,'/')">
						<xsl:value-of select="substring-before(@namewithmod,'/')" />
					</xsl:when>
					<xsl:otherwise>webscripts</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xalan:write select="concat($repdir,'/',$keyvalwithmod,'/',$keyval,'_tcReport.html')"> 
				<html>
					<head>
						<xsl:text disable-output-escaping="yes">
							<![CDATA[
<style type="text/css">
a:link{ color: #000000; text-decoration: underline;}
a:visited{ color: #000000; text-decoration: underline;}
a:active{ color: #000000; text-decoration: underline; }
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle1 a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle1 a{ text-decoration: underline; color:#000000; }
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
function MM_openBrWindow(theURL,winName,features) { //v2.0
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?datestring="+dateStr,winName,features);
}
function showPage(url)
{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

}

function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}

function showModPage(url,divid)
{
	window.parent.document.getElementById("main").src=url+"?divtoopen="+divid;
}
function invokeSummaryLeftReport()
{
	window.parent.frames[0].hideOtherDiv();
	window.parent.frames[0].changeiconnotifier();
}
function showModuleLeftReport(url)
{
	url = url.substring(0,url.indexOf("::skip"));
	window.parent.frames[0].showScriptFromTR(url);
}
</script>
						]]>
						</xsl:text>
					<title>QEngine Web Test Studio : TestCase Report</title>
					</head><!--:if expand("%") == ""|browse confirm w|else|confirm w|endif-->

					<body bgcolor="#FFFFFF" text="#000000" onload="checkForPrint();">
						<table cellspacing="0" cellpadding="0" align="center" border="0" width="99%">
							<tr>
								<td height="30" colspan="2" class="bodytext"><a href="javascript:showPage('scriptsummary.html');" onclick="javascript:invokeSummaryLeftReport();">Summary Report</a> &gt; <a href="javascript:showPage('scriptsummary.html');" onclick="javascript:invokeSummaryLeftReport();"> <xsl:value-of select="/validation_report/testconfigdetails/@suitename" /> </a> &gt; <a href="javascript:showModPage('{concat($modnamefortcreport,'.html')}','{concat($modnamefortcreport,'_div')}')" onclick="javascript:showModuleLeftReport('{concat($modnamefortcreport,'::skip')}');"> <xsl:value-of select="$modnamefortcreport"/> </a> &gt; <a href="#"> <xsl:value-of select="$keyval"/></a> &gt; Testcase Report</td>
							</tr>
							<tr bgcolor="#ffffff">
								<td width="23%" class="reporth3">Testcase Report</td>
								<td id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('{concat($keyval,'_tcReport')}','PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
							</tr>
							<tr>
								<td height="1" colspan="3"><span class="reporthline"><img height="1" width="1" src="/framework/images/spacer.gif"></img></span></td>
								</tr>
								<tr>
									<td height="30" colspan="2" class="reporth2">The Testcase Reports which shows both the summary and detailed view of all the testcases configured in the script.</td>
								</tr>
							</table>
							<div align="right">
								<span class="tdlinkflevel">
									<xsl:choose>
										<xsl:when test="$outfile='multiple'">
											<a href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=out')}" class="tdlinkflevel" target="_new">outfile</a> 
										</xsl:when>
										<xsl:otherwise>
											<a href="{concat('../',$modadjusturlval,$pathToLogsDirFromSum,'/',$keyvalwithmod,'/testout0.txt')}" class="tdlinkflevel" target="_new">outfile</a>
										</xsl:otherwise>
									</xsl:choose>| 
									<xsl:choose>
										<xsl:when test="$errfile='multiple'">
											<a href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=err')}" class="tdlinkflevel" target="_new">errFile</a>
										</xsl:when>
										<xsl:otherwise>
											<xsl:choose>
												<xsl:when test="$errfile='empty'">
													<a class="tdlinkflevel" href="/framework/html/noerror.html" target="_new">errFile</a>
												</xsl:when>
												<xsl:otherwise>
													<a href="{concat('../',$modadjusturlval,$pathToLogsDirFromSum,'/',$keyvalwithmod,'/testerr0.txt')}" class="tdlinkflevel" target="_new">errfile</a>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:otherwise>
									</xsl:choose>
								</span>

							</div>

						<xsl:choose>
					<xsl:when test="count($casereport)>0">
						<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0" class="reporttablebg">
<tr>
<td height="24" class="thstyle"> Report Summary</td>
</tr>
<tr>
<td>
<table border="0" cellspacing="0" cellpadding="5" align="center" width="100%">
	<tr>
		<th class="thstyle1">Severity</th>
							<xsl:for-each select="$statusreport">
					                      <th class="thstyle1"><xsl:value-of select="."/></th>	
				                        </xsl:for-each>
					                      <th class="thstyle1">Total</th>
					                    </tr>

											<xsl:for-each select="$severityreport">
												<xsl:variable name="sevname" select="@name"/>	
												<tr bgcolor="#FFFFFF" class="tdstyle" align="center">

												<td class="tdstyle" ><center><font color="{@color}"><xsl:value-of select="$sevname"/></font></center></td>
												<xsl:for-each select="$statusreport">
													<xsl:variable name="statusvalue" select="."/>
													<td class="tdstyle"><xsl:value-of select="count($casereport[@status=$statusvalue and @severity=$sevname])"/></td>	
												</xsl:for-each>					
												<td class="tdstyle" ><xsl:value-of select="count($casereport[@severity=$sevname])"/></td>
											</tr>	
							</xsl:for-each>

							  <tr align="center" class="tdstyle" bgcolor="#FFFFFF">
								<td class="tdstyle" >Total</td>
				 			<xsl:for-each select="$statusreport">
							  <xsl:variable name="statusvalue" select="."/>
							  <xsl:variable name="statcount" select="count($casereport[@status=$statusvalue])"/>		
						          <xsl:choose>
							    <xsl:when test="$statcount>0">
					                      <td class="tdstyle"> <xsl:value-of select="$statcount"/></td>
				   			    </xsl:when>	
							    <xsl:otherwise>
				  			      <td class="tdstyle"> <xsl:value-of select="$statcount"/></td>
							    </xsl:otherwise>
							  </xsl:choose>
							</xsl:for-each>	
				                    	      <td class="tdstyle"> <xsl:value-of select="count($casereport)"/></td>			   			  
							  </tr>					
							</table>
						    </td>    
					          </tr>
					        </table>
							<br></br>
							<div align="center">
								<table width="99%" border="0"  cellpadding="0" cellspacing="0" class="reporttablebg">
									<tr>
										<td height="24" align="left" bgcolor="#FFFFFF" class="thstyle">Detailed Report
										</td>
									</tr>
									<tr>
										<td>
											<table  cellpadding="4" align="center" cellspacing="0" border="0" width="100%">
												<tr align="center" class="thstyle1" >
													<td class="thstyle1" width="15%"> 
														Id
													</td>
													<td class="thstyle1" width="15%"> 
														Severity
													</td>
													<td class="thstyle1" width="10%"> 
														Status
													</td>
													<td class="thstyle1" width="15%"> 
														Debug Information
													</td>
													<td class="thstyle1" width="15%"> 
														ExpectedValue
													</td>
													<td class="thstyle1" width="15%"> 
														ActualValue
													</td>
													<td class="thstyle1" width="15%"> 
														Remarks
													</td>
												</tr>
											<xsl:for-each select="$scriptnode1/testcases/case">

											<xsl:sort order="ascending" select="@time" data-type="number"/>
												<xsl:variable name="casenode" select="."/>
												<xsl:variable name="idFromScript" select="@id"/>
												<xsl:variable name="severity" select="@severity"/>
												<xsl:variable name="status" select="@status"/>
												<xsl:variable name="debugInfo" select="@debuginfo"/>
												<xsl:variable name="remarks" select="@logmessage"/>
												<xsl:variable name="scriptid" select="@scriptid"/>
												<xsl:variable name="expectedvalue" select="@expectedvalue"/>
												<xsl:variable name="actualvalue" select="@actualvalue"/>																	<xsl:variable name="temp" select="position() mod 2"/>
												<tr class="{concat('tdstyle',$temp)}">
													<td align="left" class="tdstyle" ><xsl:value-of select="$idFromScript"/></td>
													<td class="tdstyle" ><xsl:value-of select="$severity"/> </td>
													<xsl:if test="$status='FAILED'">
														<td class="tdstyle" ><font color="#ff0000"><xsl:value-of select="$status"/></font></td>
													</xsl:if>
													<xsl:if test="$status='PASSED'">
														<td class="tdstyle" ><font color="#009900"><xsl:value-of select="$status"/></font></td>
													</xsl:if>
													<xsl:if test="$status='DATA_ERROR'">
														<td class="tdstyle" ><font color="#AF0000"><xsl:value-of select="$status"/></font></td>
													</xsl:if>
													<xsl:if test="$status='ENVIRONMENT_ERROR'">
														<td class="tdstyle" ><font color="#AF0000"><xsl:value-of select="$status"/></font></td>
													</xsl:if>
													<xsl:if test="$status='INCOMPLETE'">
														<td class="tdstyle" ><font color="#0000CC"><xsl:value-of select="$status"/></font></td>
													</xsl:if>



													<td class="tdstyle"  height="10"><xsl:value-of select="$debugInfo"/> </td>
													<td class="tdstyle" align="left"  height="10"><xsl:value-of select="$expectedvalue"/> </td>
													<td class="tdstyle" align="left"  height="10"><xsl:value-of select="$actualvalue"/> </td>													
													<td class="tdstyle" align="left"  height="10"><xsl:value-of select="$remarks"/> 
			<xsl:if test="$keyvalwithmod!=@scriptid">
				<xsl:text>&#x0a;</xsl:text>- Script : <xsl:value-of select="$scriptid"/>
			</xsl:if>	
								</td>
												</tr>
											</xsl:for-each>
										</table>
									</td>
								</tr>
							</table>
						</div>
					</xsl:when>
					<xsl:otherwise>
						<table width="500" height="200" border="0" align="center" cellpadding="0" cellspacing="0" bordercolor="#333333" class="reporttablebg">
  <tr>
							   <td align="center" class="thstyle1">
								<xsl:variable name="scrstatus" select="$scriptnode1/@status"/>
								<xsl:variable name="scrdebugInfo" select="$scriptnode1/@debuginfo"/>
								<xsl:variable name="license" select="$scriptnode1/testcases/@license"/>
								<xsl:choose>
									<xsl:when test="$license='FREE'">
										<h1>Not supported in Free Edition</h1>
									</xsl:when>
									<xsl:otherwise>
										<xsl:if test="$scrstatus='INCOMPLETE'">
											<xsl:value-of select="$scrdebugInfo"/>
										</xsl:if>
										<xsl:if test="$scrstatus='COMPLETED'">
											<h1>No Testcase Configured </h1>
										</xsl:if>
									</xsl:otherwise>
								</xsl:choose>
						   	</td>
						   </tr>
						</table>
					</xsl:otherwise>
					</xsl:choose>
					</body>
				</html>
			</xalan:write> 
		</xsl:for-each>
		<xalan:write select="concat($repdir,'/','scriptsummary.html')">
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thstyle a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}

.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle a{ text-decoration: underline; color:#000000; }
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
function MM_openBrWindow(theURL,winName,features) { //v2.0
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?datestring="+dateStr,winName,features);
  }
   
  function showPage(url)
	{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

	}

	function showReportPage(elem)
	{
		window.location.href = elem ;
	}
  function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}

  </script>

					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Script Summary</title>
				</head>
				<body bgcolor="#FFFFFF" text="#000000" onload="checkForPrint();">
					<xsl:variable name="failurecount" select="count(/validation_report/report/script/testcases/case[@status='FAILED'])" /> 
					<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
					<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
					<xsl:variable name="licensemode" select="/validation_report/testconfigdetails/@licensetype" />
					
					<table border='0' cellspacing='0' cellpadding='0' width='100%'>
							<tr valign="top">
  								<td height="25" colspan="2" class="subthstyle">Summary Report </td>
							</tr>
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>
							<tr>
								<td colspan="2" class="reporth2"> Testcase execution summary report </td> 
							</tr>
					</table>
	

					<table border='0' cellspacing='0' cellpadding='0' class='' width='100%'> <tr> <td colspan='2'>
					<table border='0' cellspacing='3' cellpadding='4' class='' align='left' style="background-color:#D0D0D0" width="40%">
							<tr>
								<td class="thstyle"><strong>Suite Name</strong></td> <td class="tdstyle"> <xsl:value-of select="/validation_report/testconfigdetails/@suitename" /> </td>
							</tr>
							<tr>
								<td class="thstyle"><strong>Test start time</strong></td> <td class="tdstyle"> <xsl:value-of select="/validation_report/testconfigdetails/@date" /> </td>
							</tr>
							<tr>
								<td class="thstyle"> <strong>Execution Time</strong>  </td> <td class="tdstyle">  <xsl:value-of select="/validation_report/testconfigdetails/@duration" /> Seconds </td>
							</tr>
							<tr>
								<td class="thstyle"><strong> Browser</strong> </td> <td class="tdstyle"> <xsl:value-of select="$browsername"/><xsl:value-of select="$browserversion"/> </td>
							</tr>
							<tr>
								<td class="thstyle"> <strong> Operating System </strong>  </td> <td class="tdstyle"> <xsl:value-of select="/validation_report/testconfigdetails/@os" /> </td>
							</tr>
							<tr>
							<tr>
								<td class="thstyle"> <strong> Total Testcase Executed </strong>  </td> <td class="tdstyle"> <xsl:value-of select="$totalcount" /> </td>
							</tr>
								<xsl:if test="$totalcount=0">
									<td class="thstyle"> <strong> Testcase failure percentage </strong> </td> <td class="tdstyle"> 0% </td>
								</xsl:if>
								<xsl:if test="$totalcount &gt; 0">
									<td class="thstyle"> <strong> Testcase failure percentage </strong> </td> <td class="tdstyle"> <xsl:value-of select="format-number(number($failurecount div $totalcount)*100,'##.##')"/>% </td>
								</xsl:if>
							</tr>
						</table> </td> </tr> </table>
						<br/>
						<br/>
						<br/>

						<table border='0' cellspacing='0' cellpadding='0' width='100%'> <tr> <td colspan='2'>
						<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0">
							<!--Going to include the TestCase summary Report here -->
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
										<tr>
											<td width="30%" class="reporth3">TestCase Summary Report</td>
											<td width="70%" id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('scriptsummary', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>

							<tr>
								<td height="25"  class="reporth2">The Summary Report shows the summary view of all the TestCases and Checkpoint executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2">
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>
							</tr>
						</table> </td> </tr> </table>

						<table align="center" width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
							<tr>
								<td>
									<table width="100%" border="0" cellpadding="5" cellspacing="1">
										<tr class="thstyle1" align="center">
											<th class="thstyle" width="10%">Module Name</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Failed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Passed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Pending</th>
											<th class="thstyle" width="6%">Total</th>
										</tr>
										<tr class="thstyle1" align="center">
											<th class="tdstyle"/>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle"/>
										</tr>

										

								<xsl:for-each select="/validation_report/report/script/testcases/case">
									<xsl:variable name="moduleval" select="@scriptid"/>
									<xsl:variable name="modulename" select="substring-before($moduleval,'/')" />
								</xsl:for-each>

								<!--<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:choose>
											<xsl:when test="not(contains(@scriptid,'/'))">
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/>-webscripts </td>
												</tr>
											</xsl:when>
											<xsl:otherwise>
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/> </td> 
												</tr>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:for-each> -->
									<xsl:variable name="licenseStat" select="/validation_report/testconfigdetails/@licensetype"/>
									<xsl:choose>
										<xsl:when test="$tcasecount=0">
											<tr>
												<xsl:if test="$licenseStat='Free Version'">
													<td colspan="14" align="center" class="subthstyle">Free Version does not report Testcase Reports</td>
												</xsl:if>
												<xsl:if test="not($licenseStat='Free Version')">
													<td colspan="14" align="center" class="subthstyle">No TestCase Configured</td>
												</xsl:if>
											</tr>
										</xsl:when>
										<xsl:otherwise>
											
										

									<xsl:for-each select="$uniquemodules">
										<xsl:variable name="modname" select="@name" />
										<xsl:variable name="temp" select="position() mod 2"/>
										<tr class="{concat('tdstyle',$temp)}" align="center">
											<td align="left" width="10%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"><xsl:value-of select="@name"/></a></td>
											<xsl:for-each select="$tcasestatus">
												<xsl:variable name="statval" select="@name"/>
												<xsl:for-each select="$severityreport">
													<xsl:variable name="sevname" select="@name"/>

													<xsl:if test="$statval='PASSED' or $statval='FAILED'">
													
														<xsl:if test="$modname!='webscripts'">
															<xsl:variable name="idref" select="concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)"/>
																<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and (substring-before(@scriptid,'/')=$modname)])"/> </a> </td>
														</xsl:if>
														
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and not(contains(@scriptid,'/'))])"/> </a> </td>
														</xsl:if>
														
													
													</xsl:if>
													
													<xsl:if test="$statval='PENDING'">
														
														<xsl:if test="$modname!='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and (substring-before(@scriptid,'/')=$modname) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and not(contains(@scriptid,'/')) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
													</xsl:if>
												
												</xsl:for-each>
											</xsl:for-each>

											<xsl:if test="$modname!='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/'))=$modname])"/> </a> </td>
											</xsl:if>
											<xsl:if test="$modname='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[not(contains(@scriptid,'/'))])"/> </a> </td>
											</xsl:if>
											
										</tr>
									</xsl:for-each>

									<tr class="thstyle1" align="center">
										<td  width="10%" class="thstyle" align="left">Total</td>
										<xsl:for-each select="$tcasestatus">
											<xsl:variable name="tcstatusval" select="@name" />
											<xsl:for-each select="$severityreport">
												<xsl:variable name="severityval" select="@name" />
												<xsl:variable name="statcount">
													<xsl:choose>
														<xsl:when test="$tcstatusval='PENDING'">
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" />
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$tcstatusval and @severity=$severityval])" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<!--<xsl:if test="@status='PASSED' or @status='FAILED'">-->
													<td width="7%" class="tdstyle"> <a href="#" onclick="showReportPage('{concat('./',$tcstatusval,'.html?divtoopen=',$tcstatusval,'_',$severityval)}');"> <xsl:value-of select="$statcount" /> </a></td>
													<!--</xsl:if>
												<xsl:if test="@status='PENDING'">
													<td width="7%" class="tdstyle"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" /> </td>
												</xsl:if>-->
											</xsl:for-each>
										</xsl:for-each>
										<td width="6%" class="tdstyle"> <a href="#" onclick="showReportPage('./total.html');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" /> </a> </td>
									</tr>


									</xsl:otherwise>
									</xsl:choose>

									
									</table>


								</td>
							</tr>
						</table>
					
						<xsl:variable name="licenseType" select="/validation_report/testconfigdetails/@licensetype"/>
						<xsl:if test="$licenseType='Free Version'">
							<font class="reporth2">Free version does not report Testcase reports. To know the limitation of Free version <a href="http://www.manageengine.com/products/qengine/comparison.html" target="_blank">click here</a>. To upgrade to the professional version <a href="https://store.adventnet.com/jsp/fp.jsp?filter=10034" target="_blank">click here</a>.</font>
						</xsl:if>
							
						<!-- TestCase Summary Report included -->
						<br/>
						<br/>
						<br/>
						
						<table width="99%" border="0" cellspacing="0" cellpadding="0" align="center">
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
									<tr>
										<td colspan="2" width="30%" class="reporth3">Script Summary Report</td>
									</tr>
									</table>
								</td>
							</tr>

						  	<tr> 
						    <td colspan="2" height="1"><span class="reporthline"><img src="/framework/images/spacer.gif" width="1" height="1"/></span></td>
						  </tr>
						  <tr>
							  <td height="25"  class="reporth2">The Summary Report shows the summary view of all the scripts executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2" >
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>

						</tr>
					</table>
					   <table align="center" width="100%" border="0" cellspacing="0" cellpadding="0"  class="reporttablebg">
					        <tr> 
					            <td>       
					                <table width="100%" align="center" cellpadding="5" cellspacing="1" border="0">
					                    <tr align="center" class="thstyle">
				  			      <th width="26%"  class="thstyle">Name</th>
					                      <th rowspan="1" colspan="2" class="thstyle">Script Result</th>
												 <!--<th rowspan="1" colspan="5" class="thstyle">Testcase Result</th>-->
								  <th rowspan="1" colspan="2" class="thstyle">Logs</th>
								  <th rowspan="1" colspan="2" class="thstyle">Execution Time</th>
							    </tr>
							    <tr align="center">
								  			<th rowspan="1" class="thstyle1" width="26%"></th>
					              			<th rowspan="1" class="thgreenstyle">Passed</th>
					              			<th rowspan="1" class="thredstyle">Failed</th>
												<!--<th rowspan="1" class="thgreenstyle">Passed</th>
							      <th rowspan="1" class="thredstyle">Failed</th>
							      <th rowspan="1" class="thstyle1">Incomplete</th>
							      <th rowspan="1" class="thstyle1">Error</th>
									<th rowspan="1" class="thstyle1">Total</th>-->
							      <th rowspan="1" class="thstyle1">Outfile</th>
								  <th rowspan="1" class="thstyle1">Errfile</th>
								  <th rowspan="1" class="thstyle1">(in secs)</th>
					                    </tr>
							<xsl:for-each select="$scriptDetails">
							<xsl:variable name="scriptnode1" select="."/>
							<xsl:variable name="scriptcasenode" select="$scriptnode1/scriptcases/case"/>
							<xsl:variable name="casereport" select="$scriptnode1/testcases/case"/>
							<xsl:variable name="keyvalwithmod" select="@namewithmod"/>
							<xsl:variable name="keyval" select="@name"/>
							<xsl:variable name="executiontime" select="@executiontime"/>
							<xsl:variable name="temp" select="position() mod 2"/>
							<tr class="{concat('tdstyle',$temp)}">
								   <td  width="26%" class="tdstyle" align="left"><a  target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html#failuresLink')}');"> <xsl:value-of select="$keyvalwithmod"/></a></td>
								   <td class="tdstyle" align="center"><a target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html#completeStatusLink')}');"><xsl:value-of select="count($scriptcasenode[@status ='PASSED' or @status='COMPLETED'])"/></a></td>
								   <td class="tdstyle" align="center"><a  target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'.html#failuresLink')}');"><xsl:value-of select="count($scriptcasenode[@status!='COMPLETED' and @status!='PASSED'])"/></a></td>
								   
									<!--<td class="tdstyle" align="center"><a target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"><xsl:value-of select="count($casereport[@status='PASSED'])"/></a></td>
								   <td class="tdstyle" align="center"><a target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"><xsl:value-of select="count($casereport[@status='FAILED'])"/></a></td>
								   <td class="tdstyle" align="center"><a target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"><xsl:value-of select="count($casereport[@status='INCOMPLETE'])"/></a></td>
								   <td class="tdstyle" align="center"><a target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"><xsl:value-of select="count($casereport[@status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])"/></a></td>
									<td class="tdstyle" align="center"><a target="main" href="javascript:showPage('{concat('./',$keyvalwithmod,'/',$keyval,'_tcReport.html')}');"><xsl:value-of select="count($casereport)"/></a></td> -->
								   <td class="tdstyle" align="center">
										<xsl:choose>
											<xsl:when test="$outfile='multiple'">
												<a href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=out')}" class="tdlinkflevel" target="_new"><img src="/framework/images/reportoutfile.gif" border="0"/></a> 
											</xsl:when>
											<xsl:otherwise>
												<a target="_new" class="tdlinkflevel" href="{concat($pathToLogsDirFromSum,'/',$keyvalwithmod,'/testout0.txt')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a>
											</xsl:otherwise>
										</xsl:choose>
									</td>
									<td class="tdstyle" align="center">
										<xsl:choose>
											<xsl:when test="$errfile='multiple'">
												<a href="{concat('/framework/jsp/DirectoryList.jsp?file=',$pathToLogsDirFromIns,'/',$keyvalwithmod,'&amp;category=err')}" class="tdlinkflevel" target="_new"><img src="/framework/images/reporterrfile.gif" border="0"/></a>
											</xsl:when>
											<xsl:otherwise>
												<xsl:choose>
													<xsl:when test="$errfile='empty'">
														<a class="tdlinkflevel" href="/framework/html/noerror.html" target="_new"><img src="/framework/images/reporterrfile.gif" border="0"/></a>
													</xsl:when>
													<xsl:otherwise>
														<a target="_new" class="tdlinkflevel" href="{concat($pathToLogsDirFromSum,'/',$keyvalwithmod,'/testerr0.txt')}"><img src="/framework/images/reporterrfile.gif" border="0"/></a>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:otherwise>
										</xsl:choose>
									</td>
									<td class="tdstyle" align="center">
										<xsl:value-of select="$executiontime"/>
									</td>
							    </tr>
							</xsl:for-each>
							</table>
						    </td>
						</tr>
					   </table>
				</body>
			</html>
		</xalan:write>



		<xalan:write select="concat($repdir,'/','PASSED.html')">
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thstyle a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}

.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle a{ text-decoration: underline; color:#000000; }
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
	function MM_openBrWindow(theURL,winName,features) { //v2.0
	winurl = window.document.URL;
		divtoopenup = winurl.substring(winurl.indexOf("=")+1);
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?divtoopen="+divtoopenup,winName,features);
  }
   
  function showPage(url)
	{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

	}
  function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}


function loadDiv()
{
	urlvalue = window.document.URL;
	divtoopen = urlvalue.substring(urlvalue.indexOf("=")+1,urlvalue.length);
	showDiv(divtoopen);
}

function showDiv(elem)
{
hideAllDiv();
divtoshow = document.getElementById(elem);
eval("divtoshow.style.display='block';");
}

	function hideAllDiv()
	{
		divArr = document.getElementsByTagName("DIV");
		for(var j=0;j<divArr.length;j++)
		{
			divid = divArr[j].id;
			divtohide = document.getElementById(divid);
			eval("divtohide.style.display='none';");
		}
	}
function showReportPage(elem)
{
	window.location.href=elem;
}

  </script>

					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Script Summary</title>
				</head>
				<body onload="loadDiv();checkForPrint();">

					<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0">
							<tr valign="top">
								<td height="25" colspan="2" class="tdlinkslevel"><a href="javascript:showPage('scriptsummary.html');">Summary Report </a>&gt; </td>
							</tr>

							<!--Going to include the TestCase summary Report here -->
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
										<tr>
											<td width="30%" class="reporth3">TestCase Summary Report</td>
											<td width="70%" id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('PASSED', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>

							<tr>
								<td height="25"  class="reporth2">The Summary Report shows the summary view of all the TestCases and Checkpoint executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2">
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>
							</tr>
						</table>

						<table align="center" width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
							<tr>
								<td>
									<table width="100%" border="0" cellpadding="5" cellspacing="1">
										<tr class="thstyle1" align="center">
											<th class="thstyle" width="10%">Module Name</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Failed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Passed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Pending</th>
											<th class="thstyle" width="6%">Total</th>
										</tr>
										<tr class="thstyle1" align="center">
											<th class="tdstyle"/>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle"/>
										</tr>

										

								<xsl:for-each select="/validation_report/report/script/testcases/case">
									<xsl:variable name="moduleval" select="@scriptid"/>
									<xsl:variable name="modulename" select="substring-before($moduleval,'/')" />
								</xsl:for-each>

								<!--<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:choose>
											<xsl:when test="not(contains(@scriptid,'/'))">
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/>-webscripts </td>
												</tr>
											</xsl:when>
											<xsl:otherwise>
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/> </td> 
												</tr>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:for-each> -->

									<xsl:for-each select="$uniquemodules">
										<xsl:variable name="modname" select="@name" />
										<xsl:variable name="temp" select="position() mod 2"/>
										<tr class="{concat('tdstyle',$temp)}" align="center">
											<td align="left" width="10%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"><xsl:value-of select="@name"/></a></td>
											<xsl:for-each select="$tcasestatus">
												<xsl:variable name="statval" select="@name"/>
												<xsl:for-each select="$severityreport">
													<xsl:variable name="sevname" select="@name"/>

													<xsl:if test="$statval='PASSED' or $statval='FAILED'">
													
														<xsl:if test="$modname!='webscripts'">
															<xsl:variable name="idref" select="concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)"/>
																<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and (substring-before(@scriptid,'/')=$modname)])"/> </a> </td>
														</xsl:if>
														
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and not(contains(@scriptid,'/'))])"/> </a> </td>
														</xsl:if>
														
													
													</xsl:if>
													
													<xsl:if test="$statval='PENDING'">
														
														<xsl:if test="$modname!='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and (substring-before(@scriptid,'/')=$modname) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and not(contains(@scriptid,'/')) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
													</xsl:if>
												
												</xsl:for-each>
											</xsl:for-each>

											<xsl:if test="$modname!='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/'))=$modname])"/> </a> </td>
											</xsl:if>
											<xsl:if test="$modname='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[not(contains(@scriptid,'/'))])"/> </a> </td>
											</xsl:if>
											
										</tr>
									</xsl:for-each>

									<tr class="thstyle1" align="center">
										<td  width="10%" class="thstyle" align="left">Total</td>
										<xsl:for-each select="$tcasestatus">
											<xsl:variable name="tcstatusval" select="@name" />
											<xsl:for-each select="$severityreport">
												<xsl:variable name="severityval" select="@name" />
												<xsl:variable name="statcount">
													<xsl:choose>
														<xsl:when test="$tcstatusval='PENDING'">
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" />
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$tcstatusval and @severity=$severityval])" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<!--<xsl:if test="@status='PASSED' or @status='FAILED'">-->
													<td width="7%" class="tdstyle"> <a href="#" onclick="showReportPage('{concat('./',$tcstatusval,'.html?divtoopen=',$tcstatusval,'_',$severityval)}');"> <xsl:value-of select="$statcount" /> </a></td>
													<!--</xsl:if>
												<xsl:if test="@status='PENDING'">
													<td width="7%" class="tdstyle"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" /> </td>
												</xsl:if>-->
											</xsl:for-each>
										</xsl:for-each>
										<td width="6%" class="tdstyle"> <a href="#" onclick="showReportPage('./total.html');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" /> </a> </td>
									</tr>

									
									</table>


								</td>
							</tr>
						</table>


						<!-- TestCase Summary Report included -->
						<br/>
						<br/>
						<br/>


						<xsl:for-each select="$severityreport">
							<xsl:variable name="severityname" select="@name" />
							<xsl:variable name="colorcode" select="@color" />
						<div id="{concat('PASSED_',$severityname)}" style="display:none;">
							<table border='0' cellspacing='1' cellpadding='10' class='0' width='100%'>
									<xsl:variable name="testcount" select="count(/validation_report/report/script/testcases/case[@status='PASSED' and @severity=$severityname])" />
									<tr style="background-color:#5AAC00;">
										<td><font color="#FFFFFF"><strong><center><xsl:value-of select="format-number(number($testcount div $totalcount)*100,'##.##')" />% of TestCase has been Passed with severity <xsl:value-of select="$severityname" /> </center></strong></font></td>
									</tr>
								</table>

											<br/>
											<br/>

								<label class="subthstyle"> <strong>Passed TestCase Summary with <xsl:value-of select="$severityname" /> severity </strong></label>
								<table border='0' cellspacing='0' cellpadding='0' width='100%' class=''>
									<tr height='10'> <td/>
									</tr>
								</table>
								<table border='0' cellspacing='0' cellpadding='0' width="100%" class="reporttablebg">
									<tr>
										<td>
											<table border='0' cellspacing='1' cellpadding='5' class='0' width='100%'>
												<tr class="thstyle1" align="center">
													<th class="thstyle"> TestCase ID </th>
													<th class="thstyle"> Module Name </th>
													<th class="thstyle"> Severity </th>
													<th class="thstyle"> Status </th>
													<th class="thstyle"> Debug Info </th>
													<th class="thstyle"> Expected Values </th>
													<th class="thstyle"> Actual Values </th>
													<th class="thstyle"> Remarks </th>
												</tr>
												
												<xsl:variable name="count1" select="count(/validation_report/report/script/testcases/case[@status='PASSED' and @severity=$severityname])" />
												<xsl:if test="$count1=0">
												<tr class="tdstyle0">
													<td colspan="8" align="center" class="tdstyle"> <strong> No TestCase Available </strong> </td>
												</tr>
												</xsl:if>
												
												<xsl:for-each select="/validation_report/report/script/testcases/case">
													<xsl:variable name="modulestring" select="@scriptid" />
													<xsl:sort select="substring-before(@scriptid,'/')" />
													<xsl:variable name="testcount" select="count(/validation_report/report/script/testcases/case[@status='PASSED' and @severity=$severityname])" />
													<xsl:if test="@status='PASSED' and @severity=$severityname">
														<xsl:variable name="temp" select="position() mod 2" />
														<tr class="concat('tdstyle',$temp)" align="center">
															<td class="tdstyle"> <xsl:value-of select="@id" /> </td>

															<xsl:choose>
																<xsl:when test="contains($modulestring,'/')">
																	<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')"/> </td>
																</xsl:when>
																<xsl:otherwise>
																	<td class="tdstyle"> webscripts </td>
																</xsl:otherwise>													
															</xsl:choose>

															<!--<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')" /> </td>-->
															<xsl:if test="@severity='ShowStopper'">
																<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<xsl:if test="@severity='Critical'">
																<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<xsl:if test="@severity='Major'">
																<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<xsl:if test="@severity='Minor'">
																<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<td class="tdstyle"> <font color="#008300"> <xsl:value-of select="@status" /> </font> </td>
															<td class="tdstyle"> <xsl:value-of select="@debuginfo" /> </td>
															<td class="tdstyle"> <xsl:value-of select="@expectedvalue" /> </td>
															<td class="tdstyle"> <xsl:value-of select="@actualvalue" /> </td>
															<td class="tdstyle"> <xsl:value-of select="@logmessage" /> </td>
														</tr>
													</xsl:if>
												</xsl:for-each>
											</table>
										</td>
									</tr>
								</table>
							</div>
					</xsl:for-each>

					<!-- Test Case Summary to be included -->

				
				</body>
			</html>
		</xalan:write>


		<!-- HTML Page for Pending request -->
		<xalan:write select="concat($repdir,'/','PENDING.html')">
			<html>
				<head> 
					<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thstyle a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}

.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle a{ text-decoration: underline; color:#000000; }
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
function MM_openBrWindow(theURL,winName,features) { //v2.0
	winurl = window.document.URL;
		divtoopenup = winurl.substring(winurl.indexOf("=")+1);
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?divtoopen="+divtoopenup,winName,features);
  }
   
  function showPage(url)
	{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

	}
  function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}


function loadDiv()
{
	urlvalue = window.document.URL;
	divtoopen = urlvalue.substring(urlvalue.indexOf("=")+1,urlvalue.length);
	showDiv(divtoopen);
}

function showDiv(elem)
{
hideAllDiv();
divtoshow = document.getElementById(elem);
eval("divtoshow.style.display='block';");
}

	function hideAllDiv()
	{
		divArr = document.getElementsByTagName("DIV");
		for(var j=0;j<divArr.length;j++)
		{
			divid = divArr[j].id;
			divtohide = document.getElementById(divid);
			eval("divtohide.style.display='none';");
		}
	}
function showReportPage(elem)
{
	window.location.href=elem;
}
  </script>

					]]>
					</xsl:text>
					<title>Pending Report Summary </title>
				</head>
				<body onload="loadDiv();checkForPrint();">

					<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0">
							<tr valign="top">
								<td height="25" colspan="2" class="tdlinkslevel"><a href="javascript:showPage('scriptsummary.html');">Summary Report </a>&gt; </td>
							</tr>

							<!--Going to include the TestCase summary Report here -->
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
										<tr>
											<td width="30%" class="reporth3">TestCase Summary Report</td>
											<td width="70%" id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('PENDING', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>

							<tr>
								<td height="25"  class="reporth2">The Summary Report shows the summary view of all the TestCases and Checkpoint executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2">
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>
							</tr>
						</table>

						<table align="center" width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
							<tr>
								<td>
									<table width="100%" border="0" cellpadding="5" cellspacing="1">
										<tr class="thstyle1" align="center">
											<th class="thstyle" width="10%">Module Name</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Failed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Passed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Pending</th>
											<th class="thstyle" width="6%">Total</th>
										</tr>
										<tr class="thstyle1" align="center">
											<th class="tdstyle"/>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle"/>
										</tr>

										

								<xsl:for-each select="/validation_report/report/script/testcases/case">
									<xsl:variable name="moduleval" select="@scriptid"/>
									<xsl:variable name="modulename" select="substring-before($moduleval,'/')" />
								</xsl:for-each>

								<!--<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:choose>
											<xsl:when test="not(contains(@scriptid,'/'))">
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/>-webscripts </td>
												</tr>
											</xsl:when>
											<xsl:otherwise>
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/> </td> 
												</tr>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:for-each> -->

									<xsl:for-each select="$uniquemodules">
										<xsl:variable name="modname" select="@name" />
										<xsl:variable name="temp" select="position() mod 2"/>
										<tr class="{concat('tdstyle',$temp)}" align="center">
											<td align="left" width="10%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"><xsl:value-of select="@name"/></a></td>
											<xsl:for-each select="$tcasestatus">
												<xsl:variable name="statval" select="@name"/>
												<xsl:for-each select="$severityreport">
													<xsl:variable name="sevname" select="@name"/>

													<xsl:if test="$statval='PASSED' or $statval='FAILED'">
													
														<xsl:if test="$modname!='webscripts'">
															<xsl:variable name="idref" select="concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)"/>
																<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and (substring-before(@scriptid,'/')=$modname)])"/> </a> </td>
														</xsl:if>
														
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and not(contains(@scriptid,'/'))])"/> </a> </td>
														</xsl:if>
														
													
													</xsl:if>
													
													<xsl:if test="$statval='PENDING'">
														
														<xsl:if test="$modname!='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and (substring-before(@scriptid,'/')=$modname) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and not(contains(@scriptid,'/')) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
													</xsl:if>
												
												</xsl:for-each>
											</xsl:for-each>

											<xsl:if test="$modname!='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/'))=$modname])"/> </a> </td>
											</xsl:if>
											<xsl:if test="$modname='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[not(contains(@scriptid,'/'))])"/> </a> </td>
											</xsl:if>
											
										</tr>
									</xsl:for-each>

									<tr class="thstyle1" align="center">
										<td  width="10%" class="thstyle" align="left">Total</td>
										<xsl:for-each select="$tcasestatus">
											<xsl:variable name="tcstatusval" select="@name" />
											<xsl:for-each select="$severityreport">
												<xsl:variable name="severityval" select="@name" />
												<xsl:variable name="statcount">
													<xsl:choose>
														<xsl:when test="$tcstatusval='PENDING'">
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" />
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$tcstatusval and @severity=$severityval])" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<!--<xsl:if test="@status='PASSED' or @status='FAILED'">-->
													<td width="7%" class="tdstyle"> <a href="#" onclick="showReportPage('{concat('./',$tcstatusval,'.html?divtoopen=',$tcstatusval,'_',$severityval)}');"> <xsl:value-of select="$statcount" /> </a></td>
													<!--</xsl:if>
												<xsl:if test="@status='PENDING'">
													<td width="7%" class="tdstyle"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" /> </td>
												</xsl:if>-->
											</xsl:for-each>
										</xsl:for-each>
										<td width="6%" class="tdstyle"> <a href="#" onclick="showReportPage('./total.html');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" /> </a> </td>
									</tr>
									
									</table>


								</td>
							</tr>
						</table>


						<!-- TestCase Summary Report included -->

						<br/>
						<br/>
						<br/>


						<xsl:for-each select="$severityreport">
						<xsl:variable name="severityname" select="@name" />
						<div id="{concat('PENDING_',$severityname)}" style="display:none;">

								<table border='0' cellspacing='1' cellpadding='10' class='0' width='100%'>
									<xsl:variable name="testcount" select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityname])" />
									<tr style="background-color:#226CFF;">
										<td><font color="#FFFFFF"> <strong><center><xsl:value-of select="format-number(number($testcount div $totalcount)*100,'##.##')" />% of TestCase has been Pending with severity <xsl:value-of select="$severityname" /> </center></strong></font></td>
									</tr>
								</table>

											<br/>
											<br/>

								<label class="subthstyle"> <strong>Pending TestCase Summary with <xsl:value-of select="$severityname" /> severity </strong></label>
								<table border='0' cellspacing='0' cellpadding='0' width='100%' class=''>
									<tr height='10'> <td/>
									</tr>
								</table>
								<table border='0' cellspacing='0' cellpadding='0' width="100%" class="reporttablebg">
									<tr>
										<td>
											<table border='0' cellspacing='1' cellpadding='5' class='0' width='100%'>
												<tr class="thstyle1" align="center">
													<th class="thstyle"> TestCase ID </th>
													<th class="thstyle"> Module Name </th>
													<th class="thstyle"> Severity </th>
													<th class="thstyle"> Status </th>
													<th class="thstyle"> Debug Info </th>
													<th class="thstyle"> Expected Values </th>
													<th class="thstyle"> Actual Values </th>
													<th class="thstyle"> Remarks </th>
												</tr>
												
												<xsl:variable name="count1" select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityname])" />
												<xsl:if test="$count1=0">
												<tr class="tdstyle0">
													<td colspan="8" align="center" class="tdstyle"> <strong> No TestCase Available </strong> </td>
												</tr>
												</xsl:if>
												
												<xsl:for-each select="/validation_report/report/script/testcases/case">
													<xsl:variable name="modulestring" select="@scriptid" />
													<xsl:sort select="substring-before(@scriptid,'/')" />
													<xsl:if test="@severity=$severityname">
														<xsl:if test="@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'">
															<xsl:variable name="temp" select="position() mod 2" />
															<tr class="concat('tdstyle',$temp)" align="center">
																<td class="tdstyle"> <xsl:value-of select="@id" /> </td>
																<!--<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')" /> </td>-->
																<xsl:choose>
																	<xsl:when test="contains($modulestring,'/')">
																		<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')"/> </td>
																	</xsl:when>
																	<xsl:otherwise>
																		<td class="tdstyle"> webscripts </td>
																	</xsl:otherwise>
																</xsl:choose>
																<xsl:if test="@severity='ShowStopper'">
																	<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
																</xsl:if>
																<xsl:if test="@severity='Critical'">
																	<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
																</xsl:if>
																<xsl:if test="@severity='Major'">
																	<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
																</xsl:if>
																<xsl:if test="@severity='Minor'">
																	<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
																</xsl:if>
																<td class="tdstyle"> <font color="#0000FF"> <xsl:value-of select="@status" /> </font> </td>
																<td class="tdstyle"> <xsl:value-of select="@debuginfo" /> </td>
																<td class="tdstyle"> <xsl:value-of select="@expectedvalue" /> </td>
																<td class="tdstyle"> <xsl:value-of select="@actualvalue" /> </td>
																<td class="tdstyle"> <xsl:value-of select="@logmessage" /> </td>
															</tr>
														</xsl:if>
													</xsl:if>
												</xsl:for-each>
											</table>
										</td>
									</tr>
								</table>
							</div>
					</xsl:for-each>


				</body>
			</html>
		</xalan:write>



		<!-- HTML File for the failed TestCases -->


		<xalan:write select="concat($repdir,'/','FAILED.html')">
			<html>
				<head>

					<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thstyle a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}

.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle a{ text-decoration: underline; color:#000000; }
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
function MM_openBrWindow(theURL,winName,features) { //v2.0
	winurl = window.document.URL;
		divtoopenup = winurl.substring(winurl.indexOf("=")+1);
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?divtoopen="+divtoopenup,winName,features);
  }
   
  function showPage(url)
	{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

	}
  function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}

function loadDiv()
{
	urlvalue = window.document.URL;
	divtoopen = urlvalue.substring(urlvalue.indexOf("=")+1,urlvalue.length);
	showDiv(divtoopen);
}

function showDiv(elem)
{
hideAllDiv();
divtoshow = document.getElementById(elem);
eval("divtoshow.style.display='block';");
}

	function hideAllDiv()
	{
		divArr = document.getElementsByTagName("DIV");
		for(var j=0;j<divArr.length;j++)
		{
			divid = divArr[j].id;
			divtohide = document.getElementById(divid);
			eval("divtohide.style.display='none';");
		}
	}
function showReportPage(elem)
{
	window.location.href=elem;
}
  </script>

					]]>
					</xsl:text>

					<title> Failed TestCase Report Summary </title>
				</head>
				<body onload="loadDiv();checkForPrint();">
					
					<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0">
							<tr valign="top">
								<td height="25" colspan="2" class="tdlinkslevel"><a href="javascript:showPage('scriptsummary.html');">Summary Report </a>&gt; </td>
							</tr>

							<!--Going to include the TestCase summary Report here -->
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
										<tr>
											<td width="30%" class="reporth3">TestCase Summary Report</td>
											<td width="70%" id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('FAILED', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>

							<tr>
								<td height="25"  class="reporth2">The Summary Report shows the summary view of all the TestCases and Checkpoint executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2">
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>
							</tr>
						</table>

						<table align="center" width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
							<tr>
								<td>
									<table width="100%" border="0" cellpadding="5" cellspacing="1">
										<tr class="thstyle1" align="center">
											<th class="thstyle" width="10%">Module Name</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Failed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Passed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Pending</th>
											<th class="thstyle" width="6%">Total</th>
										</tr>
										<tr class="thstyle1" align="center">
											<th class="tdstyle"/>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle"/>
										</tr>

										

								<xsl:for-each select="/validation_report/report/script/testcases/case">
									<xsl:variable name="moduleval" select="@scriptid"/>
									<xsl:variable name="modulename" select="substring-before($moduleval,'/')" />
								</xsl:for-each>

								<!--<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:choose>
											<xsl:when test="not(contains(@scriptid,'/'))">
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/>-webscripts </td>
												</tr>
											</xsl:when>
											<xsl:otherwise>
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/> </td> 
												</tr>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:for-each> -->

									<xsl:for-each select="$uniquemodules">
										<xsl:variable name="modname" select="@name" />
										<xsl:variable name="temp" select="position() mod 2"/>
										<tr class="{concat('tdstyle',$temp)}" align="center">
											<td align="left" width="10%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"><xsl:value-of select="@name"/></a></td>
											<xsl:for-each select="$tcasestatus">
												<xsl:variable name="statval" select="@name"/>
												<xsl:for-each select="$severityreport">
													<xsl:variable name="sevname" select="@name"/>

													<xsl:if test="$statval='PASSED' or $statval='FAILED'">
													
														<xsl:if test="$modname!='webscripts'">
															<xsl:variable name="idref" select="concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)"/>
																<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and (substring-before(@scriptid,'/')=$modname)])"/> </a> </td>
														</xsl:if>
														
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and not(contains(@scriptid,'/'))])"/> </a> </td>
														</xsl:if>
														
													
													</xsl:if>
													
													<xsl:if test="$statval='PENDING'">
														
														<xsl:if test="$modname!='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and (substring-before(@scriptid,'/')=$modname) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and not(contains(@scriptid,'/')) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
													</xsl:if>
												
												</xsl:for-each>
											</xsl:for-each>

											<xsl:if test="$modname!='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/'))=$modname])"/> </a> </td>
											</xsl:if>
											<xsl:if test="$modname='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[not(contains(@scriptid,'/'))])"/> </a> </td>
											</xsl:if>
											
										</tr>
									</xsl:for-each>

									<tr class="thstyle1" align="center">
										<td  width="10%" class="thstyle" align="left">Total</td>
										<xsl:for-each select="$tcasestatus">
											<xsl:variable name="tcstatusval" select="@name" />
											<xsl:for-each select="$severityreport">
												<xsl:variable name="severityval" select="@name" />
												<xsl:variable name="statcount">
													<xsl:choose>
														<xsl:when test="$tcstatusval='PENDING'">
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" />
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$tcstatusval and @severity=$severityval])" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<!--<xsl:if test="@status='PASSED' or @status='FAILED'">-->
													<td width="7%" class="tdstyle"> <a href="#" onclick="showReportPage('{concat('./',$tcstatusval,'.html?divtoopen=',$tcstatusval,'_',$severityval)}');"> <xsl:value-of select="$statcount" /> </a></td>
													<!--</xsl:if>
												<xsl:if test="@status='PENDING'">
													<td width="7%" class="tdstyle"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" /> </td>
												</xsl:if>-->
											</xsl:for-each>
										</xsl:for-each>
										<td width="6%" class="tdstyle"> <a href="#" onclick="showReportPage('./total.html');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" /> </a> </td>
									</tr>

									
									</table>


								</td>
							</tr>
						</table>


						<!-- TestCase Summary Report included -->

					<br/>
					<br/>
					<br/>


					<xsl:for-each select="$severityreport">
						<xsl:variable name="severityname" select="@name" />
						<div id="{concat('FAILED_',$severityname)}" style="display:none;">

								<table border='0' cellspacing='1' cellpadding='10' class='0' width='100%'>
									<xsl:variable name="testcount" select="count(/validation_report/report/script/testcases/case[@status='FAILED' and @severity=$severityname])" />
									<tr style="background-color:#FF4440;">
										<td style="color:#FFFFFF;"><font color="#FFFFFF"> <strong><center><xsl:value-of select="format-number(number($testcount div $totalcount)*100,'##.##')" />% of testcase has been failed with severity <xsl:value-of select="$severityname" /> </center></strong></font></td>
									</tr>
								</table>

											<br/>
											<br/>

								<label class="subthstyle"> <strong>Failed TestCase Summary with <xsl:value-of select="$severityname" /> severity </strong></label>
								<table border='0' cellspacing='0' cellpadding='0' width='100%' class=''>
									<tr height='10'> <td/>
									</tr>
								</table>
								<table border='0' cellspacing='0' cellpadding='0' width="100%" class="reporttablebg">
									<tr>
										<td>
											<table border='0' cellspacing='1' cellpadding='5' class='0' width='100%'>
												<tr class="thstyle1" align="center">
													<th class="thstyle"> TestCase ID </th>
													<th class="thstyle"> Module Name </th>
													<th class="thstyle"> Severity </th>
													<th class="thstyle"> Status </th>
													<th class="thstyle"> Debug Info </th>
													<th class="thstyle"> Expected Values </th>
													<th class="thstyle"> Actual Values </th>
													<th class="thstyle"> Remarks </th>
												</tr>
												
												<xsl:variable name="count1" select="count(/validation_report/report/script/testcases/case[@status='FAILED' and @severity=$severityname])" />
												<xsl:if test="$count1=0">
												<tr class="tdstyle0">
													<td colspan="8" align="center" class="tdstyle"> <strong> No TestCase Available </strong> </td>
												</tr>
												</xsl:if>
												
												<xsl:for-each select="/validation_report/report/script/testcases/case">
													<xsl:variable name="modulestring" select="@scriptid" />
													<xsl:sort select="substring-before(@scriptid,'/')" />
													<xsl:if test="@status='FAILED' and @severity=$severityname">
														<xsl:variable name="temp" select="position() mod 2" />
														<tr class="concat('tdstyle',$temp)" align="center">
															<td class="tdstyle"> <xsl:value-of select="@id" /> </td>
															
															<xsl:choose>
																<xsl:when test="contains($modulestring,'/')">
																	<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')"/> </td>
																</xsl:when>
																<xsl:otherwise>
																	<td class="tdstyle"> webscripts </td>
																</xsl:otherwise>													
															</xsl:choose>

															<!--<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')" /> </td>-->
															<xsl:if test="@severity='ShowStopper'">
																<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<xsl:if test="@severity='Critical'">
																<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<xsl:if test="@severity='Major'">
																<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<xsl:if test="@severity='Minor'">
																<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
															</xsl:if>
															<td class="tdstyle"> <font color="#FF0000"> <xsl:value-of select="@status" /> </font> </td>
															<td class="tdstyle"> <xsl:value-of select="@debuginfo" /> </td>
															<td class="tdstyle"> <xsl:value-of select="@expectedvalue" /> </td>
															<td class="tdstyle"> <xsl:value-of select="@actualvalue" /> </td>
															<td class="tdstyle"> <xsl:value-of select="@logmessage" /> </td>
														</tr>
													</xsl:if>
												</xsl:for-each>
											</table>
										</td>
									</tr>
								</table>
							</div>
					</xsl:for-each>
					
				

				</body>
			</html>
		</xalan:write>


		<xalan:write select="concat($repdir,'/','total.html')">
			<html>
				<head>

					<xsl:text disable-output-escaping="yes">
						<![CDATA[
						<style type="text/css">
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth3 a{ text-decoration: underline; color:#000000; }
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thstyle a{ text-decoration: underline; color:#000000; }
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}

.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000000}
.tdstyle a{ text-decoration: underline; color:#000000; }
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script language="javascript">
	var d = new Date();
   dateStr = d.toGMTString();
function MM_openBrWindow(theURL,winName,features) { //v2.0
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

  window.open(theURL+".html?datestring="+dateStr,winName,features);
  }
   
  function showPage(url)
	{
	window.parent.document.getElementById("main").src=url+"?datestring="+dateStr;

	}
  function checkForPrint()
{
	//This is only for print preview window
	if(window.name=="PrintReport")
	{
		try
		{
			document.getElementById("print").innerHTML="";
			document.getElementById("print").innerHTML="<input type='button' class='button' onclick='window.print()' name='Print' value='Print'></input>";

		}
		catch(e)
		{
		}
	}
}


function loadDiv()
{
	urlvalue = window.document.URL;
	divtoopen = urlvalue.substring(urlvalue.indexOf("=")+1,urlvalue.length);
	showDiv(divtoopen);
}

function showDiv(elem)
{
hideAllDiv();
divtoshow = document.getElementById(elem);
eval("divtoshow.style.display='block';");
}

	function hideAllDiv()
	{
		divArr = document.getElementsByTagName("DIV");
		for(var j=0;j<divArr.length;j++)
		{
			divid = divArr[j].id;
			divtohide = document.getElementById(divid);
			eval("divtohide.style.display='none';");
		}
	}
function showReportPage(elem)
{
	window.location.href=elem;
}
  </script>

					]]>
					</xsl:text>

					<title> Failed TestCase Report Summary </title>
				</head>
				<body onload="checkForPrint();">

					<table width="99%" border="0" align="center" cellpadding="0" cellspacing="0">
							<tr valign="top">
								<td height="25" colspan="2" class="tdlinkslevel"><a href="javascript:showPage('scriptsummary.html');">Summary Report </a>&gt; </td>
							</tr>

							<!--Going to include the TestCase summary Report here -->
							<tr bgcolor="#ffffff">
								<td colspan="2" width="100%">
									<table width="100%">
										<tr>
											<td width="30%" class="reporth3">TestCase Summary Report</td>
											<td width="70%" id="print" align="right" valign="top" class="reporth3"><a href="javascript:MM_openBrWindow('total', 'PrintReport', 'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes')">Printer Friendly View</a> </td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td colspan="2" height="1"><span class="reporthline"> <img src="/framework/images/spacer.gif" width="1" height="1"/></span> </td>
							</tr>

							<tr>
								<td height="25"  class="reporth2"> executed in the last run.</td>
								<xsl:variable name="browsername" select="$scriptDetails/@browsername"/>
								<xsl:variable name="browserversion" select="$scriptDetails/@browserversion"/>
								<td align="right" class="reporth2">
									Browser : 
									<xsl:value-of select="$browsername"/>
									<xsl:value-of select="$browserversion"/>

									<strong>|</strong>      Mode : 
									<xsl:variable name="playmode" select="$scriptDetails/@playmode"/>
									<xsl:value-of select="$playmode"/>
								
								</td>
							</tr>
						</table>

						<table align="center" width="100%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
							<tr>
								<td>
									<table width="100%" border="0" cellpadding="5" cellspacing="1">
										<tr class="thstyle1" align="center">
											<th class="thstyle" width="10%">Module Name</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Failed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Passed</th>
											<th class="thstyle" colspan="4" rowspan="1" width="28%">Pending</th>
											<th class="thstyle" width="6%">Total</th>
										</tr>
										<tr class="thstyle1" align="center">
											<th class="tdstyle"/>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle" width="7%">ShowStopper</th>
											<th class="thstyle" width="7%">Critical</th>
											<th class="thstyle" width="7%">Major</th>
											<th class="thstyle" width="7%">Minor</th>
											<th class="thstyle"/>
										</tr>

										

								<xsl:for-each select="/validation_report/report/script/testcases/case">
									<xsl:variable name="moduleval" select="@scriptid"/>
									<xsl:variable name="modulename" select="substring-before($moduleval,'/')" />
								</xsl:for-each>

								<!--<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:choose>
											<xsl:when test="not(contains(@scriptid,'/'))">
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/>-webscripts </td>
												</tr>
											</xsl:when>
											<xsl:otherwise>
												<tr>
													<td colspan="14" class="tdstyle"> <xsl:value-of select="@scriptid"/> </td> 
												</tr>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:for-each> -->

									<xsl:for-each select="$uniquemodules">
										<xsl:variable name="modname" select="@name" />
										<xsl:variable name="temp" select="position() mod 2"/>
										<tr class="{concat('tdstyle',$temp)}" align="center">
											<td align="left" width="10%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"><xsl:value-of select="@name"/></a></td>
											<xsl:for-each select="$tcasestatus">
												<xsl:variable name="statval" select="@name"/>
												<xsl:for-each select="$severityreport">
													<xsl:variable name="sevname" select="@name"/>

													<xsl:if test="$statval='PASSED' or $statval='FAILED'">
													
														<xsl:if test="$modname!='webscripts'">
															<xsl:variable name="idref" select="concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)"/>
																<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and (substring-before(@scriptid,'/')=$modname)])"/> </a> </td>
														</xsl:if>
														
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$statval and @severity=$sevname and not(contains(@scriptid,'/'))])"/> </a> </td>
														</xsl:if>
														
													
													</xsl:if>
													
													<xsl:if test="$statval='PENDING'">
														
														<xsl:if test="$modname!='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and (substring-before(@scriptid,'/')=$modname) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
														<xsl:if test="$modname='webscripts'">
															<td class="tdstyle" width="7%"><a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_',$statval,'_',$sevname)}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@severity=$sevname and not(contains(@scriptid,'/')) and (@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR')])" /> </a> </td>														
														</xsl:if>
													
													</xsl:if>
												
												</xsl:for-each>
											</xsl:for-each>

											<xsl:if test="$modname!='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(substring-before(@scriptid,'/'))=$modname])"/> </a> </td>
											</xsl:if>
											<xsl:if test="$modname='webscripts'">
												<td align="center" width="6%"> <a href="#" onclick="showReportPage('{concat('./',$modname,'.html?divtoopen=',$modname,'_div')}');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[not(contains(@scriptid,'/'))])"/> </a> </td>
											</xsl:if>
											
										</tr>
									</xsl:for-each>

									<tr class="thstyle1" align="center">
										<td  width="10%" class="thstyle" align="left">Total</td>
										<xsl:for-each select="$tcasestatus">
											<xsl:variable name="tcstatusval" select="@name" />
											<xsl:for-each select="$severityreport">
												<xsl:variable name="severityval" select="@name" />
												<xsl:variable name="statcount">
													<xsl:choose>
														<xsl:when test="$tcstatusval='PENDING'">
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" />
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="count(/validation_report/report/script/testcases/case[@status=$tcstatusval and @severity=$severityval])" />
														</xsl:otherwise>
													</xsl:choose>
												</xsl:variable>
												<!--<xsl:if test="@status='PASSED' or @status='FAILED'">-->
													<td width="7%" class="tdstyle"> <a href="#" onclick="showReportPage('{concat('./',$tcstatusval,'.html?divtoopen=',$tcstatusval,'_',$severityval)}');"> <xsl:value-of select="$statcount" /> </a></td>
													<!--</xsl:if>
												<xsl:if test="@status='PENDING'">
													<td width="7%" class="tdstyle"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[(@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR') and @severity=$severityval])" /> </td>
												</xsl:if>-->
											</xsl:for-each>
										</xsl:for-each>
										<td width="6%" class="tdstyle"> <a href="#" onclick="showReportPage('./total.html');"> <xsl:value-of select="count(/validation_report/report/script/testcases/case[@status='PASSED' or @status='FAILED' or @status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'])" /> </a> </td>
									</tr>	
									
									</table>


								</td>
							</tr>
						</table>


						<!-- TestCase Summary Report included -->
					<br/>
					<br/>
					<br/>

					<label class="subthstyle"> <strong>Total TestCase Summary </strong></label>
								<table border='0' cellspacing='0' cellpadding='0' width='100%' class=''>
									<tr height='10'> <td/>
									</tr>
								</table>
					<table border='0' cellspacing='0' cellpadding='0' width='100%' class='reporttablebg'>
						<tr>
							<td>
								<table border='0' cellspacing='1' cellpadding='5' class=''>
									<tr class="thstyle1" align="center">
										<th class="thstyle"> TestCase ID </th>
										<th class="thstyle"> Module Name </th>
										<th class="thstyle"> Severity </th>
										<th class="thstyle"> Status </th>
										<th class="thstyle"> Debug Info </th>
										<th class="thstyle"> Expected Values </th>
										<th class="thstyle"> Actual Values </th>
										<th class="thstyle"> Remarks </th>
									</tr>
									<xsl:for-each select="/validation_report/report/script/testcases/case">
										<xsl:variable name="modulestring" select="@scriptid" />
										<xsl:sort select="substring-before(@scriptid,'/')" />
										<xsl:variable name="tdorder" select="position() mod 2" />
										<tr align="center" class="{concat('tdstyle',$tdorder)}">
											<td class="tdstyle" align="left"> <xsl:value-of select="@id"/> </td>

											<xsl:choose>
												<xsl:when test="contains($modulestring,'/')">
													<td class="tdstyle"> <xsl:value-of select="substring-before(@scriptid,'/')"/> </td>
												</xsl:when>
												<xsl:otherwise>
													<td class="tdstyle"> webscripts </td>
												</xsl:otherwise>													
											</xsl:choose>
											
											<xsl:if test="@severity='ShowStopper'">
												<td class="tdstyle"> <font color="#ff3300"> <xsl:value-of select="@severity" /> </font> </td>
											</xsl:if>
											<xsl:if test="@severity='Critical'">
												<td class="tdstyle"> <font color="#FFA0A0"> <xsl:value-of select="@severity" /> </font> </td>
											</xsl:if>
											<xsl:if test="@severity='Major'">
												<td class="tdstyle"> <font color="#800080"> <xsl:value-of select="@severity" /> </font> </td>
											</xsl:if>
											<xsl:if test="@severity='Minor'">
												<td class="tdstyle"> <font color="#00B4FO"> <xsl:value-of select="@severity" /> </font> </td>
											</xsl:if>
											
											<xsl:if test="@status='PASSED'">
												<td class="tdstyle"> <font color="#008300"> <xsl:value-of select="@status" /> </font> </td>
											</xsl:if>
											<xsl:if test="@status='FAILED'">
												<td class="tdstyle"> <font color="#FF0000"> <xsl:value-of select="@status" /> </font> </td>
											</xsl:if>
											<xsl:if test="@status='INCOMPLETE' or @status='DATA_ERROR' or @status='ENVIRONMENT_ERROR'">
												<td class="tdstyle"> <font color="#0000FF"> <xsl:value-of select="@status" /> </font> </td>
											</xsl:if>

											<td class="tdstyle"> <xsl:value-of select="@debuginfo" /> </td>
											<td class="tdstyle"> <xsl:value-of select="@expectedvalue" /> </td>
											<td class="tdstyle"> <xsl:value-of select="@actualvalue" /> </td>
											<td class="tdstyle"> <xsl:value-of select="@logmessage" /> </td>
										</tr>
									</xsl:for-each>
								
								</table>
							</td>
						</tr>
					</table>


				</body>
			</html>
		</xalan:write>

		
		

		<xalan:write select="concat($repdir,'/','index.html')">
			<html>
				<head>
				<link href="{concat('/','framework','/','styles','/',$currentTheme,'/','qengine.css')}" rel="stylesheet" type="text/css"/>
				<title>QEngine Web Test Studio : Script Report</title>
				<script>
					function showPage(url)
					{
						window.frames[0].clearStyles();
						var d = new Date();
						var dateStr = d.toGMTString();
						document.getElementById("main").src=url+"?datestring="+dateStr;
					}

					function showTCPage(url)
					{
						var d = new Date();
						var dateStr = d.toGMTString();
						document.getElementById("main").src=url+"?datestring="+dateStr;
					}
					
					function showModPage(url,divid)
					{
						document.getElementById("main").src=url+"?divtoopen="+divid;
					}
					
					
				</script>
				</head>

					<frameset rows="*" framespacing="0" border="0" frameborder="0" cols="210,*">
						<frame src="{concat('left','.','html','?','datestring','=',$dateVal)}" scrolling="auto" name="left"/>
						<frame src="{concat('scriptsummary','.','html','?','datestring','=',$dateVal)}" id="main" name="main"/>
					</frameset>
				<noframes> 
					<body bgcolor="#FFFFFF" text="#000000">
					</body>
				</noframes> 
					
			</html>
		</xalan:write>
	</xsl:template>
</xsl:stylesheet>

